; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: VIDEO2.PAS
 
.nolist
.INCLUDE "m48def.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        TAKTFREQUENZ  =  0x5666 ; WORD
.equ        TAKTFREQUENZ_MHZ  =  0x0016 ; WORD
.equ        CTC_WERT  =  0x02C8 ; WORD
.equ        LAENGE_VLINE_ARRAY  =  0x020D ; WORD
.equ        WAITKON  =  0x0016 ; WORD
.equ        WAITKON2  =  0x03DE ; WORD
 
; *** Variablentabelle ***
 
.dseg
 
STEUER_STRING:   ; String(20)
.byte     1     ; STRING-Laenge
.byte     20
WERT_YL:   ; Byte
.byte     1
WERT_YH:   ; Byte
.byte     1
WERT_R17:   ; Byte
.byte     1
WRITE_STRING:   ; String(50)
.byte     1     ; STRING-Laenge
.byte     50
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        RJMP       RESET
 
; Timer/Counter1 Compare Match A
.ORG OC1Aaddr
        RJMP       TIMER1_COMPA
 
; PROCEDURE - Anfang (TIMER0_AUS)
TIMER0_AUS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0A)
        OUT        TCCR0A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0B)
        OUT        TCCR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIMSK0)
        STS        TIMSK0, R16
 
; PROCEDURE - Ende (TIMER0_AUS)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER0_OVF)
INIT_TIMER0_OVF:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0A)
        OUT        TCCR0A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x04)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (TCCR0B)
        OUT        TCCR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TIMSK0)
        STS        TIMSK0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIFR0)
        OUT        TIFR0, R16
 
; PROCEDURE - Ende (INIT_TIMER0_OVF)
        RET
 
; PROCEDURE - Anfang (TIMER1_AUS)
TIMER1_AUS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR1A)
        STS        TCCR1A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR1B)
        STS        TCCR1B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIMSK1)
        STS        TIMSK1, R16
 
; PROCEDURE - Ende (TIMER1_AUS)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER1_COMPA)
INIT_TIMER1_COMPA:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x09)
        LDI        R16, 0x09
 
; Zuweisung Ziel /  VAR (TCCR1B)
        STS        TCCR1B, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(WERT)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(WERT)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (OCR1AH)
        STS        OCR1AH, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (OCR1AL)
        STS        OCR1AL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (TIMSK1)
        STS        TIMSK1, R16
 
; PROCEDURE - Ende (INIT_TIMER1_COMPA)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER2_OVF)
INIT_TIMER2_OVF:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR2A)
        STS        TCCR2A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (TCCR2B)
        STS        TCCR2B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ASSR)
        STS        ASSR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TIMSK2)
        STS        TIMSK2, R16
 
; PROCEDURE - Ende (INIT_TIMER2_OVF)
        RET
 
; FUNCTION - Anfang (BYTEPOSTOORMASKE)
BYTEPOSTOORMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_03
        RJMP       M_CASE_02
M_CASE_03:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_02:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_05
        RJMP       M_CASE_04
M_CASE_05:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x02
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_04:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_07
        RJMP       M_CASE_06
M_CASE_07:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x04
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_06:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_09
        RJMP       M_CASE_08
M_CASE_09:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x08
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_08:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_011
        RJMP       M_CASE_010
M_CASE_011:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x10
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_010:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_013
        RJMP       M_CASE_012
M_CASE_013:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x20
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_012:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_015
        RJMP       M_CASE_014
M_CASE_015:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x40
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_014:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_017
        RJMP       M_CASE_016
M_CASE_017:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x80
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
 
; CASE OF ELSE
M_CASE_016:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; ENDCASE;
M_CASE_01:
 
; Ende Byte - FUNCTION (BYTEPOSTOORMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOORMASKE)
        RET
 
; FUNCTION - Anfang (BYTEPOSTOANDMASKE)
BYTEPOSTOANDMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_020
        RJMP       M_CASE_019
M_CASE_020:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_019:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_022
        RJMP       M_CASE_021
M_CASE_022:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFD
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_021:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_024
        RJMP       M_CASE_023
M_CASE_024:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFB
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_023:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_026
        RJMP       M_CASE_025
M_CASE_026:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xF7
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_025:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_028
        RJMP       M_CASE_027
M_CASE_028:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xEF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_027:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_030
        RJMP       M_CASE_029
M_CASE_030:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xDF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_029:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_032
        RJMP       M_CASE_031
M_CASE_032:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xBF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_031:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_034
        RJMP       M_CASE_033
M_CASE_034:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0x7F
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
 
; CASE OF ELSE
M_CASE_033:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; ENDCASE;
M_CASE_018:
 
; Ende Byte - FUNCTION (BYTEPOSTOANDMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOANDMASKE)
        RET
 
; FUNCTION - Anfang (READ_BIT_IN_BYTE)
READ_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (READ_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        RCALL      BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (READ_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_038
        CLR        R16
        RJMP       M_VERGL_039
M_VERGL_038:
        SER        R16
M_VERGL_039:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_035
        RJMP       M_IF_036
M_IF_035:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0x00
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_037
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_036:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0xFF
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_037:
 
; Ende Byte - FUNCTION (READ_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (READ_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (SET_BIT_IN_BYTE)
SET_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        RCALL      BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (SET_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (SET_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (CLEAR_BIT_IN_BYTE)
CLEAR_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOANDMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOANDMASKE)
        RCALL      BYTEPOSTOANDMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (CLEAR_BIT_IN_BYTE)
        RET
 
; PROCEDURE - Anfang (WAIT_MS)
WAIT_MS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (ZEIT)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_040:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_041
        RJMP       M_FTD_042
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_041:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (WAITKON2)
        LDI        R16, LOW(0x03DE)
        LDI        R17, HIGH(0x03DE)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_043:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_044
        RJMP       M_FTD_045
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_044:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_043
 
; FOR TO DO - Ende
M_FTD_045:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_040
 
; FOR TO DO - Ende
M_FTD_042:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (WAIT_MS)
        RET
 
; PROCEDURE - Anfang (BYTETOSTRING)
BYTETOSTRING:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_049
        CLR        R16
        RJMP       M_VERGL_050
M_VERGL_049:
        SER        R16
M_VERGL_050:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_046
        RJMP       M_IF_047
M_IF_046:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_048
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_047:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_048:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_051
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_051:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_053
        MOV        R16, R17
M_PRG_CONST_STRING_052:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_052
M_PRG_CONST_STRING_053:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_057
        CLR        R16
        RJMP       M_VERGL_058
M_VERGL_057:
        SER        R16
M_VERGL_058:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_054
        RJMP       M_IF_055
M_IF_054:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_056
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_055:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_056:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXLOW)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_059
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_059:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_061
M_PRG_CONST_STRING_060:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_060
M_PRG_CONST_STRING_061:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_062
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_062:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_064
        MOV        R16, R17
M_PRG_CONST_STRING_063:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_063
M_PRG_CONST_STRING_064:
        ST         -Z, R17
 
; PROCEDURE - Ende (BYTETOSTRING)
        RET
 
; FUNCTION - Anfang (STRINGTOBYTE)
STRINGTOBYTE:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_068
        CLR        R16
        RJMP       M_VERGL_069
M_VERGL_068:
        SER        R16
M_VERGL_069:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_065
        RJMP       M_IF_066
M_IF_065:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN - Ende
M_IF_066:
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_073
        CLR        R16
        RJMP       M_VERGL_074
M_VERGL_073:
        SER        R16
M_VERGL_074:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_070
        RJMP       M_IF_071
M_IF_070:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_071:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (STRINGTOBYTE)
        MOV        R0, R3
 
; Ende Byte - FUNCTION (STRINGTOBYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (STRINGTOBYTE)
        RET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x4C)
        LDI        R16, 0x4C
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x3F)
        LDI        R16, 0x3F
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTD)
        OUT        PORTD, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; ISR - Einsprung
TIMER1_COMPA:
        PUSH       R16
        IN         R16,SREG
        PUSH       R16
 
; ASM
; Verwaltung der Ports
; ---------------------

.equ 	port_control_b	= portb
.equ 	port_control_c	= portc
.equ 	port_adr_hig	= portd

.equ 	ddr_control_b	= ddrb
.equ 	ddr_control_c	= ddrc
.equ 	ddr_adr_hig	= ddrd



; *** port_control_b ***
.equ 	A18		= 0			; Adresse A18
.equ	LED_GE		= 2			; LED_GE -> gelbe LED



; *** port_control_c ***
.equ 	HSYNC		= 0			; Horizontale Synchronimpulse Pin 13
.equ 	VSYNC		= 1			; Vertikale Synchronimpulse Pin 14

.equ	START_CNT	= 2			; /START_CNT = Start des Zaehlers -> Low active
.equ	RESET_CNT	= 3			; RESET_CNT = Ruecksetzen des Zaehlers auf 0 -> High active

.equ 	WE		= 4			; /WE fuer SRAM
.equ 	OE		= 5			; /OE fuer SRAM



; VERTICAL LINE CONTROL
.equ 	VL_RESET	= 0			;
.equ 	VL_VER_IMP	= 1			;
.equ 	VL_OUT_VA	= 2			;
.equ 	VL_INC_VA	= 3			;
.equ 	VL_A18	        = 4			;


	lds	R16,tcnt1l
	cpi	R16,12
	brlo	LATFIX1			

LATFIX1:
	cpi	R16,13
	brlo	LATFIX2			

LATFIX2:
	cpi	R16,14
	brlo	LATFIX3			

LATFIX3:
	cpi	R16,15
	brlo	LATFIX4			

LATFIX4:

; HORIZONTAL SYNC LOW
	cbi	port_control_c, HSYNC


	push	R17

	push	zl
	push	zh
	push	yl
	push	yh

	lds	yl, Wert_yl
	lds	yh, Wert_yh

	lds	R17, Wert_R17

;	sbi	port_control_b, LED_GE


; SET POINTER TO VLINE TABLE
	ldi	zl,low(2*VLINE)
	ldi	zh,high(2*VLINE)


; SET VLINE TABLE POSITION
	add	zl,yl
	adc	zh,yh


; READ VLINE TABLE BYTE
	lpm	R16,z


; INCREMENT VERTICAL ADDRESS
	sbrs	R16,VL_INC_VA
	inc	R17


; RESET VERTICAL ADDRESS
	sbrc	R16,VL_RESET
	ser	R17


; INCREMENT VLINE COUNTER
	adiw	yh:yl,1				


; RESET VLINE COUNTER
	sbrc	R16,VL_RESET			
	clr	yl
	sbrc	R16,VL_RESET			
	clr	yh

      	sts	Wert_yl, yl
	sts	Wert_yh, yh


; VERTICAL SYNC CONTROL
	sbrc	R16, VL_VER_IMP	
	cbi	port_control_c, VSYNC
	sbrs	R16, VL_VER_IMP		
	sbi	port_control_c, VSYNC


; HORIZONTAL SYNC HIGH
	sbi	port_control_c, HSYNC


; Setzen oder Ruecksetzen von A18
	sbrc	R16, VL_A18
	sbi	port_control_b, A18
	sbrs	R16, VL_A18
	cbi	port_control_b, A18



; SET VERTICAL ADDRESS
	sbrc	R16,VL_OUT_VA
	out	port_adr_hig,R17

	sts	Wert_R17, R17


; CONTROL ACTIVE LINES
	sbrs	R16,VL_OUT_VA
	rjmp	NOVID


; (4)

; Ruecksetzen des Zaehlers
	sbi		port_control_c, RESET_CNT	; 2

; SET SRAM TO READ
	cbi		port_control_c, OE		; 2
	cbi		port_control_c, RESET_CNT	; 2

; (10)

; Starten des Zaehlers
	sbi		port_control_c, START_CNT	; 2


	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

; (100)

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

; (200)


	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

 	nop
	nop									; 1
	nop
 	nop
	nop									; 1
	nop
	nop
 	nop
	nop									; 1
	nop

	nop
 	nop
	nop									; 1
	nop
	nop
 	nop
	nop									; 1
	nop
	nop
 	nop

; 300


	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop



 	nop
	nop									; 1
	nop
 	nop
	nop									; 1
	nop
	nop
 	nop
	nop									; 1
	nop

	nop
 	nop
	nop									; 1
	nop
	nop
 	nop
	nop									; 1
	nop
	nop
 	nop

; 400



	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

 	nop
	nop									; 1
	nop
 	nop
	nop									; 1
	nop
	nop
 	nop
	nop									; 1
	nop

	nop
 	nop
	nop									; 1
	nop
	nop
 	nop
	nop									; 1
	nop
	nop
 	nop

; 500


	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

 	nop
	nop									; 1
	nop
 	nop
	nop									; 1
	nop
	nop
 	nop
	nop									; 1
	nop

	nop
 	nop
	nop									; 1
	nop
	nop
 	nop
	nop									; 1
	nop
;	nop
; 	nop

; 600



	cbi		port_control_c, START_CNT	; 2
	sbi		port_control_c, OE


; -----------------------------------------------



; BLANKING LINES EXIT POINT
NOVID:

	pop	yh
	pop	yl
	pop	zh
	pop	zl

	pop	r17
               

 
 
; ISR - Ende
        POP        R16
        OUT        SREG,R16
        POP        R16
        RETI
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Aufruf PROCEDURE (INITPORTS)
        RCALL      INITPORTS
 
; Word-Parameter(1) fuer PROCEDURE (INIT_TIMER1_COMPA)
        LDI        R16, LOW(0x02C8)
        MOV        R0, R16
        LDI        R17, HIGH(0x02C8)
        MOV        R1, R17
 
; Aufruf PROCEDURE (INIT_TIMER1_COMPA)
        RCALL      INIT_TIMER1_COMPA
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (WERT_YL)
        STS        WERT_YL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (WERT_YH)
        STS        WERT_YH, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (WERT_R17)
        STS        WERT_R17, R16
 
; ClearBit(LED_GE)
        CBI        PORTB, 2
 
; ClearBit(HSYNC)
        CBI        PORTC, 0
 
; ClearBit(VSYNC)
        CBI        PORTC, 1
 
; ClearBit(START_CNT)
        CBI        PORTC, 2
 
; ClearBit(RESET_CNT)
        CBI        PORTC, 3
 
; SetBit(WE)
        SBI        PORTC, 4
 
; SetBit(OE)
        SBI        PORTC, 5
 
; ClearBit(VCON_A10)
        CBI        PORTD, 0
 
; ClearBit(VCON_A11)
        CBI        PORTD, 1
 
; ClearBit(VCON_A12)
        CBI        PORTD, 2
 
; ClearBit(VCON_A13)
        CBI        PORTD, 3
 
; ClearBit(VCON_A14)
        CBI        PORTD, 4
 
; ClearBit(VCON_A15)
        CBI        PORTD, 5
 
; ClearBit(VCON_A16)
        CBI        PORTD, 6
 
; ClearBit(VCON_A17)
        CBI        PORTD, 7
 
; ClearBit(VCON_A18)
        CBI        PORTB, 0
 
; SetBit(LED_GE)
        SBI        PORTB, 2
 
; SetBit(RESET_CNT)
        SBI        PORTC, 3
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0096)
        MOV        R0, R16
        LDI        R17, HIGH(0x0096)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        RCALL      WAIT_MS
 
; ClearBit(RESET_CNT)
        CBI        PORTC, 3
 
; ClearBit(LED_GE)
        CBI        PORTB, 2
 
; Interrupt erlauben
        SEI
 
; LOOP - Start_Marke
M_LOOP_075:
 
; LOOP - Ende
        RJMP       M_LOOP_075
 
; *** Namen-Liste ***
;
; UDR0 (V) BYTECONVAR
; UBRR0H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; TWAMR (V) BYTECONVAR
; TWCR (V) BYTECONVAR
; TWDR (V) BYTECONVAR
; TWAR (V) BYTECONVAR
; TWSR (V) BYTECONVAR
; TWBR (V) BYTECONVAR
; ASSR (V) BYTECONVAR
; OCR2B (V) BYTECONVAR
; OCR2A (V) BYTECONVAR
; TCNT2 (V) BYTECONVAR
; TCCR2B (V) BYTECONVAR
; TCCR2A (V) BYTECONVAR
; TIMSK2 (V) BYTECONVAR
; TIMSK1 (V) BYTECONVAR
; TIMSK0 (V) BYTECONVAR
; OCR1BL (V) BYTECONVAR
; OCR1BH (V) BYTECONVAR
; OCR1AH (V) BYTECONVAR
; OCR1AL (V) BYTECONVAR
; ICR1L (V) BYTECONVAR
; ICR1H (V) BYTECONVAR
; TCNT1L (V) BYTECONVAR
; TCNT1H (V) BYTECONVAR
; TCCR1C (V) BYTECONVAR
; TCCR1B (V) BYTECONVAR
; TCCR1A (V) BYTECONVAR
; DIDR1 (V) BYTECONVAR
; DIDR0 (V) BYTECONVAR
; ADMUX (V) BYTECONVAR
; ADCSRB (V) BYTECONVAR
; ADCSRA (V) BYTECONVAR
; ADCH (V) BYTECONVAR
; ADCL (V) BYTECONVAR
; PCMSK0 (V) BYTECONVAR
; PCMSK1 (V) BYTECONVAR
; PCMSK2 (V) BYTECONVAR
; PCMSK3 (V) BYTECONVAR
; EICRA (V) BYTECONVAR
; PCICR (V) BYTECONVAR
; OSCCAL (V) BYTECONVAR
; PRR0 (V) BYTECONVAR
; CLKPR (V) BYTECONVAR
; WDTCSR (V) BYTECONVAR
; SREG (V) BYTECONREG
; SPL (V) BYTECONREG
; SPH (V) BYTECONREG
; SPMCSR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; SMCR (V) BYTECONREG
; OCDR (V) BYTECONREG
; ACSR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; GPIOR0 (V) BYTECONREG
; GPIOR1 (V) BYTECONREG
; GPIOR2 (V) BYTECONREG
; OCR0A (V) BYTECONREG
; OCR0B (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; TCCR0A (V) BYTECONREG
; TCCR0B (V) BYTECONREG
; GTCCR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; EIMSK (V) BYTECONREG
; EIFR (V) BYTECONREG
; PCIFR (V) BYTECONREG
; TIFR2 (V) BYTECONREG
; TIFR1 (V) BYTECONREG
; TIFR0 (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; RXC0 (B) BIT
; TXC0 (B) BIT
; UDRE0 (B) BIT
; TIMER0_AUS (P) 
; INIT_TIMER0_OVF (P) 
; TIMER1_AUS (P) 
; INIT_TIMER1_COMPA (P) 
; INIT_TIMER2_OVF (P) 
; TAKTFREQUENZ (C) WORD Wert=0x5666
; TAKTFREQUENZ_MHZ (C) WORD Wert=0x0016
; CTC_WERT (C) WORD Wert=0x02C8
; LAENGE_VLINE_ARRAY (C) WORD Wert=0x020D
; VLINE (A) 
; LED_GE (B) BIT
; HSYNC (B) BIT
; VSYNC (B) BIT
; START_CNT (B) BIT
; RESET_CNT (B) BIT
; WE (B) BIT
; OE (B) BIT
; VCON_A10 (B) BIT
; VCON_A11 (B) BIT
; VCON_A12 (B) BIT
; VCON_A13 (B) BIT
; VCON_A14 (B) BIT
; VCON_A15 (B) BIT
; VCON_A16 (B) BIT
; VCON_A17 (B) BIT
; VCON_A18 (B) BIT
; STEUER_STRING (V) STRING
; WERT_YL (V) BYTE
; WERT_YH (V) BYTE
; WERT_R17 (V) BYTE
; WAITKON (C) WORD Wert=0x0016
; WAITKON2 (C) WORD Wert=0x03DE
; WRITE_STRING (V) STRING
; BYTEPOSTOORMASKE (F) 
; BYTEPOSTOANDMASKE (F) 
; READ_BIT_IN_BYTE (F) 
; SET_BIT_IN_BYTE (F) 
; CLEAR_BIT_IN_BYTE (F) 
; WAIT_MS (P) 
; BYTETOSTRING (P) 
; STRINGTOBYTE (F) 
; INITPORTS (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE TIMER0_AUS;
; PROCEDURE INIT_TIMER0_OVF;
; PROCEDURE TIMER1_AUS;
; PROCEDURE INIT_TIMER1_COMPA (WERT : WORD) (B_WERT_L : BYTE) (B_WERT_H : BYTE);
; PROCEDURE INIT_TIMER2_OVF;
; FUNCTION BYTEPOSTOORMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION BYTEPOSTOANDMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION READ_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (VERGLEICH : BYTE) (MASKE : BYTE) : BOOLEAN;
; FUNCTION SET_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION CLEAR_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; PROCEDURE WAIT_MS (ZEIT : WORD) (W1 : WORD) (W2 : WORD);
; PROCEDURE BYTETOSTRING (WERT_BYTE : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE) (C1 : CHAR);
; FUNCTION STRINGTOBYTE (HEXLOW : BYTE) (HEXHIGH : BYTE) (S2B : BYTE) (C1 : CHAR) : BYTE;
; PROCEDURE INITPORTS;
 
; *** Konstanten-ARRAYs ***
;
 
VLINE:
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x14,0x14
.db    0x08,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x02
.db    0x02,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x01,0x00
 
; *** ISR-Liste ***
;
; Nummer=2    ORG=INT0addr     ISR=INT0          Bemerkung=External Interrupt Request 0
; Nummer=3    ORG=INT1addr     ISR=INT1          Bemerkung=External Interrupt Request 1
; Nummer=4    ORG=PCI0addr     ISR=PCINT0        Bemerkung=Pin Change Interrupt Request 0
; Nummer=5    ORG=PCI1addr     ISR=PCINT1        Bemerkung=Pin Change Interrupt Request 1
; Nummer=6    ORG=PCI2addr     ISR=PCINT2        Bemerkung=Pin Change Interrupt Request 2
; Nummer=7    ORG=WDTaddr      ISR=WDT           Bemerkung=Watchdog Time-out Interrupt
; Nummer=8    ORG=OC2Aaddr     ISR=TIMER2_COMPA  Bemerkung=Timer/Counter2 Compare Match A
; Nummer=9    ORG=OC2Baddr     ISR=TIMER2_COMPB  Bemerkung=Timer/Counter2 Compare Match B
; Nummer=10   ORG=OVF2addr     ISR=TIMER2_OVF    Bemerkung=Timer/Counter2 Overflow
; Nummer=11   ORG=ICP1addr     ISR=TIMER1_CAPT   Bemerkung=Timer/Counter1 Capture Event
; Nummer=12   ORG=OC1Aaddr     ISR=TIMER1_COMPA  Bemerkung=Timer/Counter1 Compare Match A
; Nummer=13   ORG=OC1Baddr     ISR=TIMER1_COMPB  Bemerkung=Timer/Counter1 Compare Match B
; Nummer=14   ORG=OVF1addr     ISR=TIMER1_OVF    Bemerkung=Timer/Counter1 Overflow
; Nummer=15   ORG=OC0Aaddr     ISR=TIMER0_COMPA  Bemerkung=Timer/Counter0 Compare Match A
; Nummer=16   ORG=OC0Baddr     ISR=TIMER0_COMPB  Bemerkung=Timer/Counter0 Compare Match B
; Nummer=17   ORG=OVF0addr     ISR=TIMER0_OVF    Bemerkung=Timer/Counter0 Overflow
; Nummer=18   ORG=SPIaddr      ISR=SPI_STC       Bemerkung=Serial Transfer Complete
; Nummer=19   ORG=URXCaddr     ISR=USART_RXC     Bemerkung=USART, Rx Complete
; Nummer=20   ORG=UDREaddr     ISR=USART_UDRE    Bemerkung=USART Data Register Empty
; Nummer=21   ORG=UTXCaddr     ISR=USART_TXC     Bemerkung=USART, Tx Complete
; Nummer=22   ORG=ADCCaddr     ISR=ADC_CC        Bemerkung=ADC Conversion Complete
; Nummer=23   ORG=ERDYaddr     ISR=EE_RDY        Bemerkung=EEPROM Ready
; Nummer=24   ORG=ACIaddr      ISR=ANA_COMP      Bemerkung=Analog Comparator
; Nummer=25   ORG=TWIaddr      ISR=TWI           Bemerkung=Two-wire Serial Interface
; Nummer=26   ORG=SPMRaddr     ISR=SPM_RDY       Bemerkung=Store Program Memory Ready
 
