; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: RSYNTH.PAS
 
.nolist
.INCLUDE "m16def.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        TAKTFREQUENZ  =  0x3E80 ; WORD
.equ        UBRR_VAL  =  0x33 ; BYTE
.equ        POTI1  =  0x07 ; BYTE
.equ        POTI2  =  0x03 ; BYTE
.equ        POTI3  =  0x06 ; BYTE
.equ        POTI4  =  0x02 ; BYTE
.equ        POTI5  =  0x05 ; BYTE
.equ        POTI6  =  0x01 ; BYTE
.equ        POTI7  =  0x04 ; BYTE
.equ        POTI8  =  0x00 ; BYTE
.equ        KANAL_COUNTER_MAX  =  0x07D0 ; WORD
.equ        WAITKON  =  0x0010 ; WORD
.equ        WAITKON2  =  0x02D0 ; WORD
 
; *** Variablentabelle ***
 
.dseg
 
ZAEHLER:   ; Word
.byte     2
SIN_WERT:   ; Byte
.byte     1
STEUER_STRING:   ; String(40)
.byte     1     ; STRING-Laenge
.byte     40
SENDE_STRING:   ; String(40)
.byte     1     ; STRING-Laenge
.byte     40
KANAL_NR:   ; Byte
.byte     1
WERT_POTI1:   ; Word
.byte     2
WERT_POTI2:   ; Word
.byte     2
WERT_POTI3:   ; Word
.byte     2
WERT_POTI4:   ; Word
.byte     2
WERT_POTI5:   ; Word
.byte     2
WERT_POTI6:   ; Word
.byte     2
WERT_POTI7:   ; Word
.byte     2
WERT_POTI8:   ; Word
.byte     2
WRITE_STRING:   ; String(40)
.byte     1     ; STRING-Laenge
.byte     40
WRITE_STRING_WORD:   ; String(40)
.byte     1     ; STRING-Laenge
.byte     40
ZEICHEN:   ; Byte
.byte     1
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; Timer/Counter1 Compare Match A
.ORG OC1Aaddr
        JMP        TIMER1_COMPA
 
; PROCEDURE - Anfang (INITTIMER0)
INITTIMER0:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TCCR0)
        OUT        TCCR0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TIMSK)
        OUT        TIMSK, R16
 
; PROCEDURE - Ende (INITTIMER0)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER1_COMPA)
INIT_TIMER1_COMPA:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x09)
        LDI        R16, 0x09
 
; Zuweisung Ziel /  VAR (TCCR1B)
        OUT        TCCR1B, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(WERT)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(WERT)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (OCR1AH)
        OUT        OCR1AH, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (OCR1AL)
        OUT        OCR1AL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x10)
        LDI        R16, 0x10
 
; Zuweisung Ziel /  VAR (TIMSK)
        OUT        TIMSK, R16
 
; PROCEDURE - Ende (INIT_TIMER1_COMPA)
        RET
 
; PROCEDURE - Anfang (INITPWM1)
INITPWM1:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TCCR1B)
        OUT        TCCR1B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x81)
        LDI        R16, 0x81
 
; Zuweisung Ziel /  VAR (TCCR1A)
        OUT        TCCR1A, R16
 
; PROCEDURE - Ende (INITPWM1)
        RET
 
; PROCEDURE - Anfang (INITCTC2)
INITCTC2:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; Zuweisung Ziel /  VAR (TCCR2)
        OUT        TCCR2, R16
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (OC_WERT)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (OCR2)
        OUT        OCR2, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x80)
        LDI        R16, 0x80
 
; Zuweisung Ziel /  VAR (TIMSK)
        OUT        TIMSK, R16
 
; PROCEDURE - Ende (INITCTC2)
        RET
 
; PROCEDURE - Anfang (INITPWM2)
INITPWM2:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x69)
        LDI        R16, 0x69
 
; Zuweisung Ziel /  VAR (TCCR2)
        OUT        TCCR2, R16
 
; PROCEDURE - Ende (INITPWM2)
        RET
 
; FUNCTION - Anfang (BYTEPOSTOORMASKE)
BYTEPOSTOORMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_03
        RJMP       M_CASE_02
M_CASE_03:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_02:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_05
        RJMP       M_CASE_04
M_CASE_05:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x02
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_04:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_07
        RJMP       M_CASE_06
M_CASE_07:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x04
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_06:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_09
        RJMP       M_CASE_08
M_CASE_09:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x08
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_08:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_011
        RJMP       M_CASE_010
M_CASE_011:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x10
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_010:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_013
        RJMP       M_CASE_012
M_CASE_013:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x20
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_012:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_015
        RJMP       M_CASE_014
M_CASE_015:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x40
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_014:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_017
        RJMP       M_CASE_016
M_CASE_017:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x80
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
 
; CASE OF ELSE
M_CASE_016:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; ENDCASE;
M_CASE_01:
 
; Ende Byte - FUNCTION (BYTEPOSTOORMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOORMASKE)
        RET
 
; FUNCTION - Anfang (BYTEPOSTOANDMASKE)
BYTEPOSTOANDMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_020
        RJMP       M_CASE_019
M_CASE_020:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_019:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_022
        RJMP       M_CASE_021
M_CASE_022:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFD
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_021:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_024
        RJMP       M_CASE_023
M_CASE_024:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFB
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_023:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_026
        RJMP       M_CASE_025
M_CASE_026:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xF7
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_025:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_028
        RJMP       M_CASE_027
M_CASE_028:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xEF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_027:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_030
        RJMP       M_CASE_029
M_CASE_030:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xDF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_029:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_032
        RJMP       M_CASE_031
M_CASE_032:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xBF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_031:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_034
        RJMP       M_CASE_033
M_CASE_034:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0x7F
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
 
; CASE OF ELSE
M_CASE_033:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; ENDCASE;
M_CASE_018:
 
; Ende Byte - FUNCTION (BYTEPOSTOANDMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOANDMASKE)
        RET
 
; FUNCTION - Anfang (READ_BIT_IN_BYTE)
READ_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (READ_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (READ_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_038
        CLR        R16
        RJMP       M_VERGL_039
M_VERGL_038:
        SER        R16
M_VERGL_039:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_035
        RJMP       M_IF_036
M_IF_035:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0x00
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_037
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_036:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0xFF
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_037:
 
; Ende Byte - FUNCTION (READ_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (READ_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (SET_BIT_IN_BYTE)
SET_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (SET_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (SET_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (CLEAR_BIT_IN_BYTE)
CLEAR_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOANDMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOANDMASKE)
        CALL       BYTEPOSTOANDMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (CLEAR_BIT_IN_BYTE)
        RET
 
; PROCEDURE - Anfang (WAIT_MS)
WAIT_MS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (ZEIT)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_040:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_041
        RJMP       M_FTD_042
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_041:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (WAITKON2)
        LDI        R16, LOW(0x02D0)
        LDI        R17, HIGH(0x02D0)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_043:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_044
        RJMP       M_FTD_045
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_044:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_043
 
; FOR TO DO - Ende
M_FTD_045:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_040
 
; FOR TO DO - Ende
M_FTD_042:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (WAIT_MS)
        RET
 
; PROCEDURE - Anfang (BYTETOSTRING)
BYTETOSTRING:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_049
        CLR        R16
        RJMP       M_VERGL_050
M_VERGL_049:
        SER        R16
M_VERGL_050:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_046
        RJMP       M_IF_047
M_IF_046:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_048
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_047:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_048:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_051
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_051:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_053
        MOV        R16, R17
M_PRG_CONST_STRING_052:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_052
M_PRG_CONST_STRING_053:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_057
        CLR        R16
        RJMP       M_VERGL_058
M_VERGL_057:
        SER        R16
M_VERGL_058:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_054
        RJMP       M_IF_055
M_IF_054:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_056
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_055:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_056:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXLOW)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_059
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_059:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_061
M_PRG_CONST_STRING_060:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_060
M_PRG_CONST_STRING_061:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_062
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_062:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_064
        MOV        R16, R17
M_PRG_CONST_STRING_063:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_063
M_PRG_CONST_STRING_064:
        ST         -Z, R17
 
; PROCEDURE - Ende (BYTETOSTRING)
        RET
 
; PROCEDURE - Anfang (WORDTOSTRING)
WORDTOSTRING:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(WERT_WORD)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BYTE_LOW)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(WERT_WORD)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BYTE_HIGH)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WORDTOSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (BYTE_HIGH) retten
        MOV        R19, R3
 
; lokalen Parameter (BYTE_HIGH) an Prozedur (BYTETOSTRING)
        MOV        R0, R19
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (WORDTOSTRING)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING_WORD)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_065
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_065:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_067
M_PRG_CONST_STRING_066:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_066
M_PRG_CONST_STRING_067:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING_WORD) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING_WORD)
        LDI        ZH, HIGH(WRITE_STRING_WORD)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_069
        MOV        R16, R17
M_PRG_CONST_STRING_068:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_068
M_PRG_CONST_STRING_069:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (WORDTOSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (BYTE_LOW) retten
        MOV        R18, R2
 
; lokalen Parameter (BYTE_LOW) an Prozedur (BYTETOSTRING)
        MOV        R0, R18
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (WORDTOSTRING)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING_WORD)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING_WORD)
        LDI        ZH, HIGH(WRITE_STRING_WORD)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_070
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_070:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_072
M_PRG_CONST_STRING_071:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_071
M_PRG_CONST_STRING_072:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_073
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_073:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_075
M_PRG_CONST_STRING_074:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_074
M_PRG_CONST_STRING_075:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING_WORD) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING_WORD)
        LDI        ZH, HIGH(WRITE_STRING_WORD)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_077
        MOV        R16, R17
M_PRG_CONST_STRING_076:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_076
M_PRG_CONST_STRING_077:
        ST         -Z, R17
 
; PROCEDURE - Ende (WORDTOSTRING)
        RET
 
; FUNCTION - Anfang (STRINGTOBYTE)
STRINGTOBYTE:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_081
        CLR        R16
        RJMP       M_VERGL_082
M_VERGL_081:
        SER        R16
M_VERGL_082:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_078
        RJMP       M_IF_079
M_IF_078:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN - Ende
M_IF_079:
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_086
        CLR        R16
        RJMP       M_VERGL_087
M_VERGL_086:
        SER        R16
M_VERGL_087:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_083
        RJMP       M_IF_084
M_IF_083:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_084:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (STRINGTOBYTE)
        MOV        R0, R3
 
; Ende Byte - FUNCTION (STRINGTOBYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (STRINGTOBYTE)
        RET
 
; PROCEDURE - Anfang (INIT_ADC)
INIT_ADC:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xE7)
        LDI        R16, 0xE7
 
; Zuweisung Ziel /  VAR (ADCSRA)
        OUT        ADCSRA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x40)
        LDI        R16, 0x40
 
; Zuweisung Ziel /  VAR (ADMUX)
        OUT        ADMUX, R16
 
; PROCEDURE - Ende (INIT_ADC)
        RET
 
; PROCEDURE - Anfang (ADC_STARTEN)
ADC_STARTEN:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (KANAL)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS_LOW)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ERGEBNIS_LOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x40)
        LDI        R18, 0x40
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS_LOW)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (ERGEBNIS_LOW)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (ADMUX)
        OUT        ADMUX, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC7)
        LDI        R16, 0xC7
 
; Zuweisung Ziel /  VAR (ADCSRA)
        OUT        ADCSRA, R16
 
; ClearBit(LED_BL)
        CBI        PORTD, 7
 
; PROCEDURE - Ende (ADC_STARTEN)
        RET
 
; FUNCTION - Anfang (ADC_BEREIT)
ADC_BEREIT:
 
; IF THEN - Ausdruck /; BitHigh(ADC_ADSC)
        IN         R16, ADCSRA
        BST        R16, 6
        BRTS       M_VERGL_091
        CLR        R16
        RJMP       M_VERGL_092
M_VERGL_091:
        SER        R16
M_VERGL_092:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_088
        RJMP       M_IF_089
M_IF_088:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADC_OK)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_090
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_089:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADC_OK)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_090:
 
; RESULT Byte-Variable - FUNCTION (ADC_BEREIT)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (ADC_BEREIT)
        MOV        R16, R0
 
; FUNCTION - Ende (ADC_BEREIT)
        RET
 
; FUNCTION - Anfang (ADC_LESEN)
ADC_LESEN:
 
; SetBit(LED_BL)
        SBI        PORTD, 7
 
; Zuweisung Quelle - Ausdruck / Byte-REG ADCL
        IN         R16, ADCL
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS_LOW)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / Byte-REG ADCH
        IN         R16, ADCH
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS_HIGH)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(ERGEBNIS_HIGH)
        MOV        R16, R3
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS_WORD)
        MOV        R4, R16
        MOV        R5, R17
 
; SHL(ERGEBNIS_WORD) - Word
        LSL        R4
        ROL        R5
 
; SHL(ERGEBNIS_WORD) - Word
        LSL        R4
        ROL        R5
 
; SHL(ERGEBNIS_WORD) - Word
        LSL        R4
        ROL        R5
 
; SHL(ERGEBNIS_WORD) - Word
        LSL        R4
        ROL        R5
 
; SHL(ERGEBNIS_WORD) - Word
        LSL        R4
        ROL        R5
 
; SHL(ERGEBNIS_WORD) - Word
        LSL        R4
        ROL        R5
 
; SHL(ERGEBNIS_WORD) - Word
        LSL        R4
        ROL        R5
 
; SHL(ERGEBNIS_WORD) - Word
        LSL        R4
        ROL        R5
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(ERGEBNIS_LOW)
        MOV        R16, R2
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS_WORD2)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ERGEBNIS_WORD)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (ERGEBNIS_WORD2)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator OR
        OR         R16, R18
        OR         R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS_WORD)
        MOV        R4, R16
        MOV        R5, R17
 
; RESULT Word-Variable - FUNCTION (ADC_LESEN)
        MOV        R0, R4
        MOV        R1, R5
 
; Ende Word - FUNCTION (ADC_LESEN)
        MOV        R16, R0
        MOV        R17, R1
 
; FUNCTION - Ende (ADC_LESEN)
        RET
 
; PROCEDURE - Anfang (INIT_SER_PORT)
INIT_SER_PORT:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (UBRRH)
        OUT        UBRRH, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (UBRR_VAL)
        LDI        R16, 0x33
 
; Zuweisung Ziel /  VAR (UBRRL)
        OUT        UBRRL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x18)
        LDI        R16, 0x18
 
; Zuweisung Ziel /  VAR (UCSRB)
        OUT        UCSRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x86)
        LDI        R16, 0x86
 
; Zuweisung Ziel /  VAR (UCSRC)
        OUT        UCSRC, R16
 
; PROCEDURE - Ende (INIT_SER_PORT)
        RET
 
; PROCEDURE - Anfang (RX_PUFFER_ABFRAGEN)
RX_PUFFER_ABFRAGEN:
 
; IF THEN - Ausdruck /; BitHigh(RXC)
        IN         R16, UCSRA
        BST        R16, 7
        BRTS       M_VERGL_096
        CLR        R16
        RJMP       M_VERGL_097
M_VERGL_096:
        SER        R16
M_VERGL_097:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_093
        RJMP       M_IF_094
M_IF_093:
 
; Zuweisung Quelle - Ausdruck / Byte-REG UDR
        IN         R16, UDR
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_095
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_094:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; IF_THEN_ELSE - Ende
M_IF_095:
 
; PROCEDURE - Ende (RX_PUFFER_ABFRAGEN)
        RET
 
; PROCEDURE - Anfang (SENDE_ZEICHEN)
SENDE_ZEICHEN:
 
; WHILE DO ...
M_WHILE_098:
 
; WHILE - Ausdruck /; BitLow(UDRE)
        IN         R16, UCSRA
        BST        R16, 5
        BRTC       M_VERGL_0101
        CLR        R16
        RJMP       M_VERGL_0102
M_VERGL_0101:
        SER        R16
M_VERGL_0102:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_099
        RJMP       M_WHILE_0100
M_WHILE_099:
 
; WHILE DO ...
        RJMP       M_WHILE_098
M_WHILE_0100:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (S_ZEICHEN)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (UDR)
        OUT        UDR, R16
 
; PROCEDURE - Ende (SENDE_ZEICHEN)
        RET
 
; PROCEDURE - Anfang (SENDE_HEX_ZEICHEN)
SENDE_HEX_ZEICHEN:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_ZEICHEN)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0106
        CLR        R16
        RJMP       M_VERGL_0107
M_VERGL_0106:
        SER        R16
M_VERGL_0107:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0103
        RJMP       M_IF_0104
M_IF_0103:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0105
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0104:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_0105:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (HEXHIGH) retten
        MOV        R18, R2
 
; lokalen Parameter (HEXHIGH) an Prozedur (SENDE_ZEICHEN)
        MOV        R0, R18
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_ZEICHEN)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0111
        CLR        R16
        RJMP       M_VERGL_0112
M_VERGL_0111:
        SER        R16
M_VERGL_0112:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0108
        RJMP       M_IF_0109
M_IF_0108:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0110
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0109:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_0110:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (HEXLOW) retten
        MOV        R17, R1
 
; lokalen Parameter (HEXLOW) an Prozedur (SENDE_ZEICHEN)
        MOV        R0, R17
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x48
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (SENDE_HEX_ZEICHEN)
        RET
 
; PROCEDURE - Anfang (SENDE_HEX_ZEICHEN_LN)
SENDE_HEX_ZEICHEN_LN:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        PUSH       R0
 
; Aufruf PROCEDURE (SENDE_HEX_ZEICHEN)
        CALL       SENDE_HEX_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x0A
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        POP        R0
 
; PROCEDURE - Ende (SENDE_HEX_ZEICHEN_LN)
        RET
 
; PROCEDURE - Anfang (WRITE)
WRITE:
 
; Zuweisung Quelle - Ausdruck / Length(WRITE_STRING)
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R1
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0113:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0114
        RJMP       M_FTD_0115
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0114:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (B2) retten
        MOV        R19, R3
 
; lokalen Parameter (B2) an Prozedur (SENDE_ZEICHEN)
        MOV        R0, R19
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0113
 
; FOR TO DO - Ende
M_FTD_0115:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (WRITE)
        RET
 
; PROCEDURE - Anfang (WRITELN)
WRITELN:
 
; Aufruf PROCEDURE (WRITE)
        CALL       WRITE
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x0A
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; PROCEDURE - Ende (WRITELN)
        RET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC2)
        LDI        R16, 0xC2
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTD)
        OUT        PORTD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; ISR - Einsprung
TIMER1_COMPA:
        PUSH       R16
        IN         R16,SREG
        PUSH       R16
 
; ASM
; Retten der benutzten Register
        PUSH       R17
        PUSH       R18
        PUSH       R19
        PUSH       R24
        PUSH       R25
        PUSH       ZL
        PUSH       ZH

 
 
; ARRAY - Ausdruck / Word-VAR (ZAEHLER)
        LDS        R16, ZAEHLER
        LDS        R17, ZAEHLER+1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (SINTAB)
        LDI        ZL, LOW(2*SINTAB)
        LDI        ZH, HIGH(2*SINTAB)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (SIN_WERT)
        STS        SIN_WERT, R16
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (SIN_WERT)
        LDS        R16, SIN_WERT
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; INC(ZAEHLER) - Word
        LDS        R24, ZAEHLER
        LDS        R25, ZAEHLER+1
        ADIW       R25:R24, 1
        STS        ZAEHLER, R24
        STS        ZAEHLER+1, R25
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (ZAEHLER)
        LDS        R16, ZAEHLER
        LDS        R17, ZAEHLER+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0064)
        LDI        R18, LOW(0x0064)
        LDI        R19, HIGH(0x0064)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0119
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0120
M_VERGL_0119:
        SER        R16
M_VERGL_0120:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0116
        RJMP       M_IF_0117
M_IF_0116:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (ZAEHLER)
        STS        ZAEHLER, R16
        STS        ZAEHLER+1, R17
 
; IF_THEN - Ende
M_IF_0117:
 
; ASM
; Rueckholen der benutzten Register
        POP        ZH
        POP        ZL
        POP        R25
        POP        R24
        POP        R19
        POP        R18
        POP        R17

 
 
; ISR - Ende
        POP        R16
        OUT        SREG,R16
        POP        R16
        RETI
 
; PROCEDURE - Anfang (ADC_SENDEN)
ADC_SENDEN:
 
; Word-Parameter(1) fuer PROCEDURE (WORDTOSTRING)
        LDS        R0, WERT_POTI1
        LDS        R1, WERT_POTI1+1
 
; Aufruf PROCEDURE (WORDTOSTRING)
        CALL       WORDTOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SENDE_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('d')
        LDI        ZL, LOW(2*M_CONST_STRING_0)
        LDI        ZH, HIGH(2*M_CONST_STRING_0)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0121
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0121:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0123
M_PRG_CONST_STRING_0122:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0122
M_PRG_CONST_STRING_0123:
        LDI        ZL, LOW(WRITE_STRING_WORD)
        LDI        ZH, HIGH(WRITE_STRING_WORD)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0124
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0124:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0126
M_PRG_CONST_STRING_0125:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0125
M_PRG_CONST_STRING_0126:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SENDE_STRING) - Laenge in R17
        LDI        ZL, LOW(SENDE_STRING)
        LDI        ZH, HIGH(SENDE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0128
        MOV        R16, R17
M_PRG_CONST_STRING_0127:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0127
M_PRG_CONST_STRING_0128:
        ST         -Z, R17
 
; Word-Parameter(1) fuer PROCEDURE (WORDTOSTRING)
        LDS        R0, WERT_POTI2
        LDS        R1, WERT_POTI2+1
 
; Aufruf PROCEDURE (WORDTOSTRING)
        CALL       WORDTOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SENDE_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(SENDE_STRING)
        LDI        ZH, HIGH(SENDE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0129
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0129:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0131
M_PRG_CONST_STRING_0130:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0130
M_PRG_CONST_STRING_0131:
        LDI        ZL, LOW(WRITE_STRING_WORD)
        LDI        ZH, HIGH(WRITE_STRING_WORD)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0132
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0132:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0134
M_PRG_CONST_STRING_0133:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0133
M_PRG_CONST_STRING_0134:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SENDE_STRING) - Laenge in R17
        LDI        ZL, LOW(SENDE_STRING)
        LDI        ZH, HIGH(SENDE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0136
        MOV        R16, R17
M_PRG_CONST_STRING_0135:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0135
M_PRG_CONST_STRING_0136:
        ST         -Z, R17
 
; Word-Parameter(1) fuer PROCEDURE (WORDTOSTRING)
        LDS        R0, WERT_POTI3
        LDS        R1, WERT_POTI3+1
 
; Aufruf PROCEDURE (WORDTOSTRING)
        CALL       WORDTOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SENDE_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(SENDE_STRING)
        LDI        ZH, HIGH(SENDE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0137
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0137:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0139
M_PRG_CONST_STRING_0138:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0138
M_PRG_CONST_STRING_0139:
        LDI        ZL, LOW(WRITE_STRING_WORD)
        LDI        ZH, HIGH(WRITE_STRING_WORD)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0140
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0140:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0142
M_PRG_CONST_STRING_0141:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0141
M_PRG_CONST_STRING_0142:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SENDE_STRING) - Laenge in R17
        LDI        ZL, LOW(SENDE_STRING)
        LDI        ZH, HIGH(SENDE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0144
        MOV        R16, R17
M_PRG_CONST_STRING_0143:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0143
M_PRG_CONST_STRING_0144:
        ST         -Z, R17
 
; Word-Parameter(1) fuer PROCEDURE (WORDTOSTRING)
        LDS        R0, WERT_POTI4
        LDS        R1, WERT_POTI4+1
 
; Aufruf PROCEDURE (WORDTOSTRING)
        CALL       WORDTOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SENDE_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(SENDE_STRING)
        LDI        ZH, HIGH(SENDE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0145
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0145:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0147
M_PRG_CONST_STRING_0146:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0146
M_PRG_CONST_STRING_0147:
        LDI        ZL, LOW(WRITE_STRING_WORD)
        LDI        ZH, HIGH(WRITE_STRING_WORD)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0148
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0148:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0150
M_PRG_CONST_STRING_0149:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0149
M_PRG_CONST_STRING_0150:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SENDE_STRING) - Laenge in R17
        LDI        ZL, LOW(SENDE_STRING)
        LDI        ZH, HIGH(SENDE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0152
        MOV        R16, R17
M_PRG_CONST_STRING_0151:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0151
M_PRG_CONST_STRING_0152:
        ST         -Z, R17
 
; Word-Parameter(1) fuer PROCEDURE (WORDTOSTRING)
        LDS        R0, WERT_POTI5
        LDS        R1, WERT_POTI5+1
 
; Aufruf PROCEDURE (WORDTOSTRING)
        CALL       WORDTOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SENDE_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(SENDE_STRING)
        LDI        ZH, HIGH(SENDE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0153
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0153:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0155
M_PRG_CONST_STRING_0154:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0154
M_PRG_CONST_STRING_0155:
        LDI        ZL, LOW(WRITE_STRING_WORD)
        LDI        ZH, HIGH(WRITE_STRING_WORD)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0156
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0156:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0158
M_PRG_CONST_STRING_0157:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0157
M_PRG_CONST_STRING_0158:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SENDE_STRING) - Laenge in R17
        LDI        ZL, LOW(SENDE_STRING)
        LDI        ZH, HIGH(SENDE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0160
        MOV        R16, R17
M_PRG_CONST_STRING_0159:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0159
M_PRG_CONST_STRING_0160:
        ST         -Z, R17
 
; Word-Parameter(1) fuer PROCEDURE (WORDTOSTRING)
        LDS        R0, WERT_POTI6
        LDS        R1, WERT_POTI6+1
 
; Aufruf PROCEDURE (WORDTOSTRING)
        CALL       WORDTOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SENDE_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(SENDE_STRING)
        LDI        ZH, HIGH(SENDE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0161
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0161:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0163
M_PRG_CONST_STRING_0162:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0162
M_PRG_CONST_STRING_0163:
        LDI        ZL, LOW(WRITE_STRING_WORD)
        LDI        ZH, HIGH(WRITE_STRING_WORD)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0164
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0164:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0166
M_PRG_CONST_STRING_0165:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0165
M_PRG_CONST_STRING_0166:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SENDE_STRING) - Laenge in R17
        LDI        ZL, LOW(SENDE_STRING)
        LDI        ZH, HIGH(SENDE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0168
        MOV        R16, R17
M_PRG_CONST_STRING_0167:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0167
M_PRG_CONST_STRING_0168:
        ST         -Z, R17
 
; Word-Parameter(1) fuer PROCEDURE (WORDTOSTRING)
        LDS        R0, WERT_POTI7
        LDS        R1, WERT_POTI7+1
 
; Aufruf PROCEDURE (WORDTOSTRING)
        CALL       WORDTOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SENDE_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(SENDE_STRING)
        LDI        ZH, HIGH(SENDE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0169
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0169:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0171
M_PRG_CONST_STRING_0170:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0170
M_PRG_CONST_STRING_0171:
        LDI        ZL, LOW(WRITE_STRING_WORD)
        LDI        ZH, HIGH(WRITE_STRING_WORD)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0172
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0172:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0174
M_PRG_CONST_STRING_0173:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0173
M_PRG_CONST_STRING_0174:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SENDE_STRING) - Laenge in R17
        LDI        ZL, LOW(SENDE_STRING)
        LDI        ZH, HIGH(SENDE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0176
        MOV        R16, R17
M_PRG_CONST_STRING_0175:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0175
M_PRG_CONST_STRING_0176:
        ST         -Z, R17
 
; Word-Parameter(1) fuer PROCEDURE (WORDTOSTRING)
        LDS        R0, WERT_POTI8
        LDS        R1, WERT_POTI8+1
 
; Aufruf PROCEDURE (WORDTOSTRING)
        CALL       WORDTOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SENDE_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(SENDE_STRING)
        LDI        ZH, HIGH(SENDE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0177
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0177:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0179
M_PRG_CONST_STRING_0178:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0178
M_PRG_CONST_STRING_0179:
        LDI        ZL, LOW(WRITE_STRING_WORD)
        LDI        ZH, HIGH(WRITE_STRING_WORD)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0180
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0180:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0182
M_PRG_CONST_STRING_0181:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0181
M_PRG_CONST_STRING_0182:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SENDE_STRING) - Laenge in R17
        LDI        ZL, LOW(SENDE_STRING)
        LDI        ZH, HIGH(SENDE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0184
        MOV        R16, R17
M_PRG_CONST_STRING_0183:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0183
M_PRG_CONST_STRING_0184:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(SENDE_STRING)
        LDI        ZH, HIGH(SENDE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0185
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0185:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0187
M_PRG_CONST_STRING_0186:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0186
M_PRG_CONST_STRING_0187:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0189
        MOV        R16, R17
M_PRG_CONST_STRING_0188:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0188
M_PRG_CONST_STRING_0189:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; PROCEDURE - Ende (ADC_SENDEN)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_AUSWERTEN)
STEUER_STRING_AUSWERTEN:
 
; Zuweisung Quelle - Ausdruck / Length(STEUER_STRING)
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0193
        CLR        R16
        RJMP       M_VERGL_0194
M_VERGL_0193:
        SER        R16
M_VERGL_0194:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0190
        RJMP       M_IF_0191
M_IF_0190:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BUCHSTABE)
        MOV        R0, R16
 
; CASE OF - lokale, dynamische Variable VAR (BUCHSTABE)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (a)
        CPI        R16, 'a'
        BREQ       M_CASE_0197
        RJMP       M_CASE_0196
M_CASE_0197:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0201
        CLR        R16
        RJMP       M_VERGL_0202
M_VERGL_0201:
        SER        R16
M_VERGL_0202:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0198
        RJMP       M_IF_0199
M_IF_0198:
 
; SetBit(LED_BL)
        SBI        PORTD, 7
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0200
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0199:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x01')
        LDI        ZL, LOW(2*M_CONST_STRING_1)
        LDI        ZH, HIGH(2*M_CONST_STRING_1)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0203
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0203:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0205
M_PRG_CONST_STRING_0204:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0204
M_PRG_CONST_STRING_0205:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0207
        MOV        R16, R17
M_PRG_CONST_STRING_0206:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0206
M_PRG_CONST_STRING_0207:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0200:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0195
M_CASE_0196:
 
; CASE OF - vergleiche Einzel-Element (b)
        CPI        R16, 'b'
        BREQ       M_CASE_0209
        RJMP       M_CASE_0208
M_CASE_0209:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0213
        CLR        R16
        RJMP       M_VERGL_0214
M_VERGL_0213:
        SER        R16
M_VERGL_0214:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0210
        RJMP       M_IF_0211
M_IF_0210:
 
; ClearBit(LED_BL)
        CBI        PORTD, 7
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0212
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0211:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x01')
        LDI        ZL, LOW(2*M_CONST_STRING_2)
        LDI        ZH, HIGH(2*M_CONST_STRING_2)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0215
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0215:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0217
M_PRG_CONST_STRING_0216:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0216
M_PRG_CONST_STRING_0217:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0219
        MOV        R16, R17
M_PRG_CONST_STRING_0218:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0218
M_PRG_CONST_STRING_0219:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0212:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0195
M_CASE_0208:
 
; CASE OF - vergleiche Einzel-Element (c)
        CPI        R16, 'c'
        BREQ       M_CASE_0221
        RJMP       M_CASE_0220
M_CASE_0221:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0225
        CLR        R16
        RJMP       M_VERGL_0226
M_VERGL_0225:
        SER        R16
M_VERGL_0226:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0222
        RJMP       M_IF_0223
M_IF_0222:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (ADC_SENDEN)
        CALL       ADC_SENDEN
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0224
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0223:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x01')
        LDI        ZL, LOW(2*M_CONST_STRING_3)
        LDI        ZH, HIGH(2*M_CONST_STRING_3)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0227
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0227:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0229
M_PRG_CONST_STRING_0228:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0228
M_PRG_CONST_STRING_0229:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0231
        MOV        R16, R17
M_PRG_CONST_STRING_0230:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0230
M_PRG_CONST_STRING_0231:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0224:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0195
 
; CASE OF ELSE
M_CASE_0220:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x02')
        LDI        ZL, LOW(2*M_CONST_STRING_4)
        LDI        ZH, HIGH(2*M_CONST_STRING_4)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0232
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0232:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0234
M_PRG_CONST_STRING_0233:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0233
M_PRG_CONST_STRING_0234:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0236
        MOV        R16, R17
M_PRG_CONST_STRING_0235:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0235
M_PRG_CONST_STRING_0236:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0195:
 
; IF_THEN - Ende
M_IF_0191:
 
; PROCEDURE - Ende (STEUER_STRING_AUSWERTEN)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_LESEN)
STEUER_STRING_LESEN:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0D)
        LDI        R18, 0x0D
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0240
        CLR        R16
        RJMP       M_VERGL_0241
M_VERGL_0240:
        SER        R16
M_VERGL_0241:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0237
        RJMP       M_IF_0238
M_IF_0237:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0A)
        LDI        R18, 0x0A
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0245
        CLR        R16
        RJMP       M_VERGL_0246
M_VERGL_0245:
        SER        R16
M_VERGL_0246:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0242
        RJMP       M_IF_0243
M_IF_0242:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_LESEN)
        PUSH       R0
 
; Aufruf PROCEDURE (STEUER_STRING_AUSWERTEN)
        CALL       STEUER_STRING_AUSWERTEN
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_LESEN)
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (STEUER_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('')
        LDI        ZL, LOW(2*M_CONST_STRING_5)
        LDI        ZH, HIGH(2*M_CONST_STRING_5)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0247
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0247:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0249
M_PRG_CONST_STRING_0248:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0248
M_PRG_CONST_STRING_0249:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (STEUER_STRING) - Laenge in R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0251
        MOV        R16, R17
M_PRG_CONST_STRING_0250:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0250
M_PRG_CONST_STRING_0251:
        ST         -Z, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0244
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0243:
 
; Zuweisung Quelle - Ausdruck / Char-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (AKT_ZEICHEN)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (STEUER_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0252
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0252:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0254
M_PRG_CONST_STRING_0253:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0253
M_PRG_CONST_STRING_0254:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (AKT_ZEICHEN)
        MOV        R19, R0
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0255
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0255:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (STEUER_STRING) - Laenge in R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0257
        MOV        R16, R17
M_PRG_CONST_STRING_0256:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0256
M_PRG_CONST_STRING_0257:
        ST         -Z, R17
 
; IF_THEN_ELSE - Ende
M_IF_0244:
 
; IF_THEN - Ende
M_IF_0238:
 
; PROCEDURE - Ende (STEUER_STRING_LESEN)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Aufruf PROCEDURE (INITPORTS)
        CALL       INITPORTS
 
; Aufruf PROCEDURE (INIT_SER_PORT)
        CALL       INIT_SER_PORT
 
; Aufruf PROCEDURE (INIT_ADC)
        CALL       INIT_ADC
 
; ClearBit(LED_BL)
        CBI        PORTD, 7
 
; ClearBit(LED_WS)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (ZAEHLER)
        STS        ZAEHLER, R16
        STS        ZAEHLER+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (POTI1)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (KANAL_NR)
        STS        KANAL_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ADC_STARTEN)
        LDI        R16, 0x07
        MOV        R0, R16
 
; Aufruf PROCEDURE (ADC_STARTEN)
        CALL       ADC_STARTEN
 
; LOOP - Start_Marke
M_LOOP_0258:
 
; Aufruf PROCEDURE (RX_PUFFER_ABFRAGEN)
        CALL       RX_PUFFER_ABFRAGEN
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0262
        CLR        R16
        RJMP       M_VERGL_0263
M_VERGL_0262:
        SER        R16
M_VERGL_0263:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0259
        RJMP       M_IF_0260
M_IF_0259:
 
; Aufruf PROCEDURE (STEUER_STRING_LESEN)
        CALL       STEUER_STRING_LESEN
 
; IF_THEN - Ende
M_IF_0260:
 
; CASE OF - Byte-VAR (KANAL_NR)
        LDS        R16, KANAL_NR
 
; CASE OF - vergleiche Einzel-Element (POTI1)
        CPI        R16, 0x07
        BREQ       M_CASE_0266
        RJMP       M_CASE_0265
M_CASE_0266:
 
; Aufruf Funktion (ADC_BEREIT)
        CALL       ADC_BEREIT
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0267
        RJMP       M_IF_0268
M_IF_0267:
 
; Aufruf Funktion (ADC_LESEN)
        CALL       ADC_LESEN
 
; Zuweisung Ziel /  VAR (WERT_POTI1)
        STS        WERT_POTI1, R16
        STS        WERT_POTI1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (POTI2)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (KANAL_NR)
        STS        KANAL_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ADC_STARTEN)
        LDI        R16, 0x03
        MOV        R0, R16
 
; Aufruf PROCEDURE (ADC_STARTEN)
        CALL       ADC_STARTEN
 
; IF_THEN - Ende
M_IF_0268:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0264
M_CASE_0265:
 
; CASE OF - vergleiche Einzel-Element (POTI2)
        CPI        R16, 0x03
        BREQ       M_CASE_0271
        RJMP       M_CASE_0270
M_CASE_0271:
 
; Aufruf Funktion (ADC_BEREIT)
        CALL       ADC_BEREIT
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0272
        RJMP       M_IF_0273
M_IF_0272:
 
; Aufruf Funktion (ADC_LESEN)
        CALL       ADC_LESEN
 
; Zuweisung Ziel /  VAR (WERT_POTI2)
        STS        WERT_POTI2, R16
        STS        WERT_POTI2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (POTI3)
        LDI        R16, 0x06
 
; Zuweisung Ziel /  VAR (KANAL_NR)
        STS        KANAL_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ADC_STARTEN)
        LDI        R16, 0x06
        MOV        R0, R16
 
; Aufruf PROCEDURE (ADC_STARTEN)
        CALL       ADC_STARTEN
 
; IF_THEN - Ende
M_IF_0273:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0264
M_CASE_0270:
 
; CASE OF - vergleiche Einzel-Element (POTI3)
        CPI        R16, 0x06
        BREQ       M_CASE_0276
        RJMP       M_CASE_0275
M_CASE_0276:
 
; Aufruf Funktion (ADC_BEREIT)
        CALL       ADC_BEREIT
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0277
        RJMP       M_IF_0278
M_IF_0277:
 
; Aufruf Funktion (ADC_LESEN)
        CALL       ADC_LESEN
 
; Zuweisung Ziel /  VAR (WERT_POTI3)
        STS        WERT_POTI3, R16
        STS        WERT_POTI3+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (POTI4)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (KANAL_NR)
        STS        KANAL_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ADC_STARTEN)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (ADC_STARTEN)
        CALL       ADC_STARTEN
 
; IF_THEN - Ende
M_IF_0278:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0264
M_CASE_0275:
 
; CASE OF - vergleiche Einzel-Element (POTI4)
        CPI        R16, 0x02
        BREQ       M_CASE_0281
        RJMP       M_CASE_0280
M_CASE_0281:
 
; Aufruf Funktion (ADC_BEREIT)
        CALL       ADC_BEREIT
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0282
        RJMP       M_IF_0283
M_IF_0282:
 
; Aufruf Funktion (ADC_LESEN)
        CALL       ADC_LESEN
 
; Zuweisung Ziel /  VAR (WERT_POTI4)
        STS        WERT_POTI4, R16
        STS        WERT_POTI4+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (POTI5)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (KANAL_NR)
        STS        KANAL_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ADC_STARTEN)
        LDI        R16, 0x05
        MOV        R0, R16
 
; Aufruf PROCEDURE (ADC_STARTEN)
        CALL       ADC_STARTEN
 
; IF_THEN - Ende
M_IF_0283:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0264
M_CASE_0280:
 
; CASE OF - vergleiche Einzel-Element (POTI5)
        CPI        R16, 0x05
        BREQ       M_CASE_0286
        RJMP       M_CASE_0285
M_CASE_0286:
 
; Aufruf Funktion (ADC_BEREIT)
        CALL       ADC_BEREIT
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0287
        RJMP       M_IF_0288
M_IF_0287:
 
; Aufruf Funktion (ADC_LESEN)
        CALL       ADC_LESEN
 
; Zuweisung Ziel /  VAR (WERT_POTI5)
        STS        WERT_POTI5, R16
        STS        WERT_POTI5+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (POTI6)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (KANAL_NR)
        STS        KANAL_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ADC_STARTEN)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (ADC_STARTEN)
        CALL       ADC_STARTEN
 
; IF_THEN - Ende
M_IF_0288:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0264
M_CASE_0285:
 
; CASE OF - vergleiche Einzel-Element (POTI6)
        CPI        R16, 0x01
        BREQ       M_CASE_0291
        RJMP       M_CASE_0290
M_CASE_0291:
 
; Aufruf Funktion (ADC_BEREIT)
        CALL       ADC_BEREIT
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0292
        RJMP       M_IF_0293
M_IF_0292:
 
; Aufruf Funktion (ADC_LESEN)
        CALL       ADC_LESEN
 
; Zuweisung Ziel /  VAR (WERT_POTI6)
        STS        WERT_POTI6, R16
        STS        WERT_POTI6+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (POTI7)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (KANAL_NR)
        STS        KANAL_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ADC_STARTEN)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (ADC_STARTEN)
        CALL       ADC_STARTEN
 
; IF_THEN - Ende
M_IF_0293:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0264
M_CASE_0290:
 
; CASE OF - vergleiche Einzel-Element (POTI7)
        CPI        R16, 0x04
        BREQ       M_CASE_0296
        RJMP       M_CASE_0295
M_CASE_0296:
 
; Aufruf Funktion (ADC_BEREIT)
        CALL       ADC_BEREIT
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0297
        RJMP       M_IF_0298
M_IF_0297:
 
; Aufruf Funktion (ADC_LESEN)
        CALL       ADC_LESEN
 
; Zuweisung Ziel /  VAR (WERT_POTI7)
        STS        WERT_POTI7, R16
        STS        WERT_POTI7+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (POTI8)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KANAL_NR)
        STS        KANAL_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ADC_STARTEN)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (ADC_STARTEN)
        CALL       ADC_STARTEN
 
; IF_THEN - Ende
M_IF_0298:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0264
M_CASE_0295:
 
; CASE OF - vergleiche Einzel-Element (POTI8)
        CPI        R16, 0x00
        BREQ       M_CASE_0301
        RJMP       M_CASE_0300
M_CASE_0301:
 
; Aufruf Funktion (ADC_BEREIT)
        CALL       ADC_BEREIT
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0302
        RJMP       M_IF_0303
M_IF_0302:
 
; Aufruf Funktion (ADC_LESEN)
        CALL       ADC_LESEN
 
; Zuweisung Ziel /  VAR (WERT_POTI8)
        STS        WERT_POTI8, R16
        STS        WERT_POTI8+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (POTI1)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (KANAL_NR)
        STS        KANAL_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ADC_STARTEN)
        LDI        R16, 0x07
        MOV        R0, R16
 
; Aufruf PROCEDURE (ADC_STARTEN)
        CALL       ADC_STARTEN
 
; IF_THEN - Ende
M_IF_0303:
 
; ENDCASE;
M_CASE_0300:
M_CASE_0264:
 
; LOOP - Ende
        RJMP       M_LOOP_0258
 
; *** Namen-Liste ***
;
; SREG (V) BYTECONREG
; SPH (V) BYTECONREG
; SPL (V) BYTECONREG
; OCR0 (V) BYTECONREG
; OCR2 (V) BYTECONREG
; GICR (V) BYTECONREG
; GIFR (V) BYTECONREG
; TIMSK (V) BYTECONREG
; TIFR (V) BYTECONREG
; SPMCR (V) BYTECONREG
; TWCR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUCSR (V) BYTECONREG
; TCCR0 (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; OSCCAL (V) BYTECONREG
; SFIOR (V) BYTECONREG
; OCDR (V) BYTECONREG
; TCCR1A (V) BYTECONREG
; TCCR1B (V) BYTECONREG
; TCNT1H (V) BYTECONREG
; TCNT1L (V) BYTECONREG
; OCR1AH (V) BYTECONREG
; OCR1AL (V) BYTECONREG
; OCR1BH (V) BYTECONREG
; OCR1BL (V) BYTECONREG
; ICR1H (V) BYTECONREG
; ICR1L (V) BYTECONREG
; TCCR2 (V) BYTECONREG
; TCNT2 (V) BYTECONREG
; ASSR (V) BYTECONREG
; WDTCR (V) BYTECONREG
; UBRRH (V) BYTECONREG
; UBRRL (V) BYTECONREG
; UCSRC (V) BYTECONREG
; UDR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; UCSRA (V) BYTECONREG
; UCSRB (V) BYTECONREG
; ACSR (V) BYTECONREG
; ADMUX (V) BYTECONREG
; ADCSRA (V) BYTECONREG
; ADCH (V) BYTECONREG
; ADCL (V) BYTECONREG
; TWDR (V) BYTECONREG
; TWAR (V) BYTECONREG
; TWSR (V) BYTECONREG
; TWBR (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; RXC (B) BIT
; TXC (B) BIT
; UDRE (B) BIT
; INITTIMER0 (P) 
; INIT_TIMER1_COMPA (P) 
; INITPWM1 (P) 
; INITCTC2 (P) 
; INITPWM2 (P) 
; TAKTFREQUENZ (C) WORD Wert=0x3E80
; UBRR_VAL (C) BYTE Wert=0x33
; POTI1 (C) BYTE Wert=0x07
; POTI2 (C) BYTE Wert=0x03
; POTI3 (C) BYTE Wert=0x06
; POTI4 (C) BYTE Wert=0x02
; POTI5 (C) BYTE Wert=0x05
; POTI6 (C) BYTE Wert=0x01
; POTI7 (C) BYTE Wert=0x04
; POTI8 (C) BYTE Wert=0x00
; KANAL_COUNTER_MAX (C) WORD Wert=0x07D0
; LED_WS (B) BIT
; LED_BL (B) BIT
; ADC_ADSC (B) BIT
; ZAEHLER (V) WORD
; SIN_WERT (V) BYTE
; STEUER_STRING (V) STRING
; SENDE_STRING (V) STRING
; KANAL_NR (V) BYTE
; WERT_POTI1 (V) WORD
; WERT_POTI2 (V) WORD
; WERT_POTI3 (V) WORD
; WERT_POTI4 (V) WORD
; WERT_POTI5 (V) WORD
; WERT_POTI6 (V) WORD
; WERT_POTI7 (V) WORD
; WERT_POTI8 (V) WORD
; SINTAB (A) 
; WAITKON (C) WORD Wert=0x0010
; WAITKON2 (C) WORD Wert=0x02D0
; WRITE_STRING (V) STRING
; WRITE_STRING_WORD (V) STRING
; BYTEPOSTOORMASKE (F) 
; BYTEPOSTOANDMASKE (F) 
; READ_BIT_IN_BYTE (F) 
; SET_BIT_IN_BYTE (F) 
; CLEAR_BIT_IN_BYTE (F) 
; WAIT_MS (P) 
; BYTETOSTRING (P) 
; WORDTOSTRING (P) 
; STRINGTOBYTE (F) 
; INIT_ADC (P) 
; ADC_STARTEN (P) 
; ADC_BEREIT (F) 
; ADC_LESEN (F) 
; ZEICHEN (V) BYTE
; INIT_SER_PORT (P) 
; RX_PUFFER_ABFRAGEN (P) 
; SENDE_ZEICHEN (P) 
; SENDE_HEX_ZEICHEN (P) 
; SENDE_HEX_ZEICHEN_LN (P) 
; WRITE (P) 
; WRITELN (P) 
; INITPORTS (P) 
; ADC_SENDEN (P) 
; STEUER_STRING_AUSWERTEN (P) 
; STEUER_STRING_LESEN (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE INITTIMER0;
; PROCEDURE INIT_TIMER1_COMPA (WERT : WORD) (B_WERT_L : BYTE) (B_WERT_H : BYTE);
; PROCEDURE INITPWM1;
; PROCEDURE INITCTC2 (OC_WERT : BYTE);
; PROCEDURE INITPWM2;
; FUNCTION BYTEPOSTOORMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION BYTEPOSTOANDMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION READ_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (VERGLEICH : BYTE) (MASKE : BYTE) : BOOLEAN;
; FUNCTION SET_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION CLEAR_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; PROCEDURE WAIT_MS (ZEIT : WORD) (W1 : WORD) (W2 : WORD);
; PROCEDURE BYTETOSTRING (WERT_BYTE : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE) (C1 : CHAR);
; PROCEDURE WORDTOSTRING (WERT_WORD : WORD) (BYTE_LOW : BYTE) (BYTE_HIGH : BYTE);
; FUNCTION STRINGTOBYTE (HEXLOW : BYTE) (HEXHIGH : BYTE) (S2B : BYTE) (C1 : CHAR) : BYTE;
; PROCEDURE INIT_ADC;
; PROCEDURE ADC_STARTEN (KANAL : BYTE) (ERGEBNIS_LOW : BYTE) (ERGEBNIS_HIGH : BYTE);
; FUNCTION ADC_BEREIT (ADC_OK : BOOLEAN) : BOOLEAN;
; FUNCTION ADC_LESEN (ERGEBNIS_LOW : BYTE) (ERGEBNIS_HIGH : BYTE) (ERGEBNIS_WORD : WORD) (ERGEBNIS_WORD2 : WORD) : WORD;
; PROCEDURE INIT_SER_PORT;
; PROCEDURE RX_PUFFER_ABFRAGEN;
; PROCEDURE SENDE_ZEICHEN (S_ZEICHEN : BYTE);
; PROCEDURE SENDE_HEX_ZEICHEN (H_ZEICHEN : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE);
; PROCEDURE SENDE_HEX_ZEICHEN_LN (WERT_BYTE : BYTE);
; PROCEDURE WRITE (C1 : CHAR) (LAENGE : BYTE) (B1 : BYTE) (B2 : BYTE);
; PROCEDURE WRITELN;
; PROCEDURE INITPORTS;
; PROCEDURE ADC_SENDEN;
; PROCEDURE STEUER_STRING_AUSWERTEN (BUCHSTABE : CHAR) (ZEICHEN_1 : CHAR) (ZEICHEN_2 : CHAR) (LAENGE : BYTE);
; PROCEDURE STEUER_STRING_LESEN (AKT_ZEICHEN : CHAR);
 
; *** Konstanten-ARRAYs ***
;
 
SINTAB:
.db    0x80,0x87
.db    0x8F,0x96
.db    0x9E,0xA5
.db    0xAD,0xB4
.db    0xBB,0xC1
.db    0xC8,0xCE
.db    0xD3,0xD9
.db    0xDE,0xE3
.db    0xE7,0xEB
.db    0xEE,0xF1
.db    0xF4,0xF6
.db    0xF8,0xF9
.db    0xFA,0xFA
.db    0xFA,0xF9
.db    0xF8,0xF6
.db    0xF4,0xF1
.db    0xEE,0xEB
.db    0xE7,0xE3
.db    0xDE,0xD9
.db    0xD3,0xCE
.db    0xC8,0xC1
.db    0xBB,0xB4
.db    0xAD,0xA5
.db    0x9E,0x96
.db    0x8F,0x87
.db    0x80,0x78
.db    0x70,0x69
.db    0x61,0x5A
.db    0x52,0x4B
.db    0x44,0x3E
.db    0x37,0x31
.db    0x2C,0x26
.db    0x21,0x1C
.db    0x18,0x14
.db    0x11,0x0E
.db    0x0B,0x09
.db    0x07,0x06
.db    0x05,0x05
.db    0x05,0x06
.db    0x07,0x09
.db    0x0B,0x0E
.db    0x11,0x14
.db    0x18,0x1C
.db    0x21,0x26
.db    0x2C,0x31
.db    0x37,0x3E
.db    0x44,0x4B
.db    0x52,0x5A
.db    0x61,0x69
.db    0x70,0x78
 
; *** Konstanten-STRING-Liste ***
;
 
M_CONST_STRING_0:
 .db    1, "d"
 
M_CONST_STRING_1:
 .db    3, "x01"
 
M_CONST_STRING_2:
 .db    3, "x01"
 
M_CONST_STRING_3:
 .db    3, "x01"
 
M_CONST_STRING_4:
 .db    3, "x02"
 
M_CONST_STRING_5:
 .db    0, " "
 
; *** ISR-Liste ***
;
; Nummer=2    ORG=INT0addr     ISR=EXT_INT0      Bemerkung=External Interrupt Request 0
; Nummer=3    ORG=INT1addr     ISR=EXT_INT1      Bemerkung=External Interrupt Request 1
; Nummer=4    ORG=OC2addr      ISR=TIMER2_COMP   Bemerkung=Timer/Counter2 Compare Match
; Nummer=5    ORG=OVF2addr     ISR=TIMER2_OVF    Bemerkung=Timer/Counter2 Overflow
; Nummer=6    ORG=ICP1addr     ISR=TIMER1_CAPT   Bemerkung=Timer/Counter1 Capture Event
; Nummer=7    ORG=OC1Aaddr     ISR=TIMER1_COMPA  Bemerkung=Timer/Counter1 Compare Match A
; Nummer=8    ORG=OC1Baddr     ISR=TIMER1_COMPB  Bemerkung=Timer/Counter1 Compare Match B
; Nummer=9    ORG=OVF1addr     ISR=TIMER1_OVF    Bemerkung=Timer/Counter1 Overflow
; Nummer=10   ORG=OVF0addr     ISR=TIMER0_OVF    Bemerkung=Timer/Counter0 Overflow
; Nummer=11   ORG=SPIaddr      ISR=SPI_STC       Bemerkung=Serial Transfer Complete
; Nummer=12   ORG=URXCaddr     ISR=USART_RXC     Bemerkung=USART, Rx Complete
; Nummer=13   ORG=UDREaddr     ISR=USART_UDRE    Bemerkung=USART Data Register Empty
; Nummer=14   ORG=UTXCaddr     ISR=USART_TXC     Bemerkung=USART, Tx Complete
; Nummer=15   ORG=ADCCaddr     ISR=ADC_CC        Bemerkung=ADC Conversion Complete
; Nummer=16   ORG=ERDYaddr     ISR=EE_RDY        Bemerkung=EEPROM Ready
; Nummer=17   ORG=ACIaddr      ISR=ANA_COMP      Bemerkung=Analog Comparator
; Nummer=18   ORG=TWIaddr      ISR=TWI           Bemerkung=Two-wire Serial Interface
; Nummer=19   ORG=INT2addr     ISR=INT2          Bemerkung=External Interrupt Request 2
; Nummer=20   ORG=OC0addr      ISR=TIMER0_COMP   Bemerkung=Timer/Counter0 Compare Match
; Nummer=21   ORG=SPMRaddr     ISR=SPM_RDY       Bemerkung=Store Program Memory Ready
 
