
// ****************************
// *** ITP3-Server-Routinen ***
// *** Hardware-Teil        ***
// ****************************


VAR


  // Ausgangs-Definitionen
  ITP3_D0_A[PortA,0] : bit; // D0 - Ausgang
  ITP3_D1_A[PortA,1] : bit; // D1 - Ausgang
  ITP3_D2_A[PortA,2] : bit; // D2 - Ausgang
  ITP3_D3_A[PortA,3] : bit; // D3 - Ausgang

  // Port-Richtungs-Definitionen (E/A)
  ITP3_D0_D[DDRA,0] : bit;  // D0 - Ein-/Ausgang (Direction)
  ITP3_D1_D[DDRA,1] : bit;  // D1 - Ein-/Ausgang (Direction)
  ITP3_D2_D[DDRA,2] : bit;  // D2 - Ein-/Ausgang (Direction)
  ITP3_D3_D[DDRA,3] : bit;  // D3 - Ein-/Ausgang (Direction)
  ITP3_DR_D[DDRB,0] : bit;  // DR - Device Receive - (Direction)

  // Eingangs-Definitionen
  ITP3_D0_E[PinA,0] : bit;  // D0 - Eingang
  ITP3_D1_E[PinA,1] : bit;  // D1 - Eingang
  ITP3_D2_E[PinA,2] : bit;  // D2 - Eingang
  ITP3_D3_E[PinA,3] : bit;  // D3 - Eingang
  ITP3_DR_E[PinB,0] : bit;  // DR - Device Receive - Eingang


  // DS fuer Client 1
  ITP3_DS0_A[PortA,4] : bit; // DS0 - Device Select - Ausgang
  ITP3_DS0_D[DDRA,4] : bit;  // DS0 - Device Select (Direction)
  ITP3_DS0_E[PinA,4] : bit;  // DS0 - Device Select - Eingang

  ITP3_DS1_A[PortA,5] : bit; // DS1 - Device Select - Ausgang
  ITP3_DS1_D[DDRA,5] : bit;  // DS1 - Device Select (Direction)
  ITP3_DS1_E[PinA,5] : bit;  // DS1 - Device Select - Eingang

  ITP3_DS2_A[PortA,6] : bit; // DS2 - Device Select - Ausgang
  ITP3_DS2_D[DDRA,6] : bit;  // DS2 - Device Select (Direction)
  ITP3_DS2_E[PinA,6] : bit;  // DS2 - Device Select - Eingang

  ITP3_DS3_A[PortA,7] : bit; // DS3 - Device Select - Ausgang
  ITP3_DS3_D[DDRA,7] : bit;  // DS3 - Device Select (Direction)
  ITP3_DS3_E[PinA,7] : bit;  // DS3 - Device Select - Eingang



