; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: ITP3_NANO.PAS
 
.nolist
.INCLUDE "m328Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        TAKTFREQUENZ  =  0x3E80 ; WORD
.equ        UBRR_VAL  =  0x19 ; BYTE
.equ        WAITKON  =  0x0010 ; WORD
.equ        WAITKON2  =  0x02D0 ; WORD
.equ        ITP3_WHO_AM_I  =  0x01 ; BYTE
.equ        ITP3_ERROR_CODE  =  0x02 ; BYTE
.equ        ITP3_CONOUT  =  0x03 ; BYTE
.equ        ITP3_CONST  =  0x04 ; BYTE
.equ        ITP3_CONIN  =  0x05 ; BYTE
 
; *** Variablentabelle ***
 
.dseg
 
DBG_ANFANG_VAR_TABELLE:
 
BYTE_STRING:   ; String(2)
.byte     1     ; STRING-Laenge
.byte     2
WORD_STRING:   ; String(4)
.byte     1     ; STRING-Laenge
.byte     4
DWORD_STRING:   ; String(8)
.byte     1     ; STRING-Laenge
.byte     8
SER0_ZEICHEN:   ; Byte
.byte     1
SER0_STRING:   ; String(20)
.byte     1     ; STRING-Laenge
.byte     20
ITP3_STRING:   ; String(40)
.byte     1     ; STRING-Laenge
.byte     40
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; FUNCTION - Anfang (BYTEPOSTOORMASKE)
BYTEPOSTOORMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_03
        RJMP       M_CASE_02
M_CASE_03:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_02:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_05
        RJMP       M_CASE_04
M_CASE_05:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x02
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_04:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_07
        RJMP       M_CASE_06
M_CASE_07:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x04
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_06:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_09
        RJMP       M_CASE_08
M_CASE_09:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x08
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_08:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_011
        RJMP       M_CASE_010
M_CASE_011:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x10
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_010:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_013
        RJMP       M_CASE_012
M_CASE_013:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x20
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_012:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_015
        RJMP       M_CASE_014
M_CASE_015:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x40
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_014:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_017
        RJMP       M_CASE_016
M_CASE_017:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x80
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
 
; CASE OF ELSE
M_CASE_016:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; ENDCASE;
M_CASE_01:
 
; Ende Byte - FUNCTION (BYTEPOSTOORMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOORMASKE)
        RET
 
; FUNCTION - Anfang (BYTEPOSTOANDMASKE)
BYTEPOSTOANDMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_020
        RJMP       M_CASE_019
M_CASE_020:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_019:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_022
        RJMP       M_CASE_021
M_CASE_022:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFD
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_021:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_024
        RJMP       M_CASE_023
M_CASE_024:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFB
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_023:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_026
        RJMP       M_CASE_025
M_CASE_026:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xF7
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_025:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_028
        RJMP       M_CASE_027
M_CASE_028:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xEF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_027:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_030
        RJMP       M_CASE_029
M_CASE_030:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xDF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_029:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_032
        RJMP       M_CASE_031
M_CASE_032:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xBF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_031:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_034
        RJMP       M_CASE_033
M_CASE_034:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0x7F
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
 
; CASE OF ELSE
M_CASE_033:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; ENDCASE;
M_CASE_018:
 
; Ende Byte - FUNCTION (BYTEPOSTOANDMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOANDMASKE)
        RET
 
; FUNCTION - Anfang (READ_BIT_IN_BYTE)
READ_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (READ_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (READ_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_038
        CLR        R16
        RJMP       M_VERGL_039
M_VERGL_038:
        SER        R16
M_VERGL_039:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_035
        RJMP       M_IF_036
M_IF_035:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0x00
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_037
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_036:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0xFF
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_037:
 
; Ende Byte - FUNCTION (READ_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (READ_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (SET_BIT_IN_BYTE)
SET_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (SET_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (SET_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (CLEAR_BIT_IN_BYTE)
CLEAR_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOANDMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOANDMASKE)
        CALL       BYTEPOSTOANDMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (CLEAR_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (NEGATION_BYTE)
NEGATION_BYTE:
 
; ASM
    COM    R0
 
 
; RESULT Byte-Variable - FUNCTION (NEGATION_BYTE)
        MOV        R1, R0
 
; Ende Byte - FUNCTION (NEGATION_BYTE)
        MOV        R16, R1
 
; FUNCTION - Ende (NEGATION_BYTE)
        RET
 
; PROCEDURE - Anfang (WAIT_MS)
WAIT_MS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (ZEIT)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_040:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_041
        RJMP       M_FTD_042
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_041:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (WAITKON2)
        LDI        R16, LOW(0x02D0)
        LDI        R17, HIGH(0x02D0)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_043:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_044
        RJMP       M_FTD_045
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_044:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_043
 
; FOR TO DO - Ende
M_FTD_045:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_040
 
; FOR TO DO - Ende
M_FTD_042:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (WAIT_MS)
        RET
 
; PROCEDURE - Anfang (BYTETOSTRING)
BYTETOSTRING:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_049
        CLR        R16
        RJMP       M_VERGL_050
M_VERGL_049:
        SER        R16
M_VERGL_050:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_046
        RJMP       M_IF_047
M_IF_046:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_048
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_047:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_048:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_051
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_051:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_053
        MOV        R16, R17
M_PRG_CONST_STRING_052:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_052
M_PRG_CONST_STRING_053:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_057
        CLR        R16
        RJMP       M_VERGL_058
M_VERGL_057:
        SER        R16
M_VERGL_058:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_054
        RJMP       M_IF_055
M_IF_054:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_056
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_055:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_056:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXLOW)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_059
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_059:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_061
M_PRG_CONST_STRING_060:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_060
M_PRG_CONST_STRING_061:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_062
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_062:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_064
        MOV        R16, R17
M_PRG_CONST_STRING_063:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_063
M_PRG_CONST_STRING_064:
        ST         -Z, R17
 
; PROCEDURE - Ende (BYTETOSTRING)
        RET
 
; FUNCTION - Anfang (STRINGTOBYTE)
STRINGTOBYTE:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (BYTE_STRING)
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_068
        CLR        R16
        RJMP       M_VERGL_069
M_VERGL_068:
        SER        R16
M_VERGL_069:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_065
        RJMP       M_IF_066
M_IF_065:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN - Ende
M_IF_066:
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (BYTE_STRING)
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_073
        CLR        R16
        RJMP       M_VERGL_074
M_VERGL_073:
        SER        R16
M_VERGL_074:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_070
        RJMP       M_IF_071
M_IF_070:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_071:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (STRINGTOBYTE)
        MOV        R0, R3
 
; Ende Byte - FUNCTION (STRINGTOBYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (STRINGTOBYTE)
        RET
 
; PROCEDURE - Anfang (WORDTOSTRING)
WORDTOSTRING:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(WERT_WORD)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BYTE_LOW)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(WERT_WORD)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BYTE_HIGH)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WORDTOSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (BYTE_HIGH) retten
        MOV        R19, R3
 
; lokalen Parameter (BYTE_HIGH) an Prozedur (BYTETOSTRING)
        MOV        R0, R19
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (WORDTOSTRING)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WORD_STRING)=4
        LDI        R16, 4
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_075
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_075:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_077
M_PRG_CONST_STRING_076:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_076
M_PRG_CONST_STRING_077:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WORD_STRING) - Laenge in R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_079
        MOV        R16, R17
M_PRG_CONST_STRING_078:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_078
M_PRG_CONST_STRING_079:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (WORDTOSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (BYTE_LOW) retten
        MOV        R18, R2
 
; lokalen Parameter (BYTE_LOW) an Prozedur (BYTETOSTRING)
        MOV        R0, R18
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (WORDTOSTRING)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WORD_STRING)=4
        LDI        R16, 4
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_080
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_080:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_082
M_PRG_CONST_STRING_081:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_081
M_PRG_CONST_STRING_082:
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_083
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_083:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_085
M_PRG_CONST_STRING_084:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_084
M_PRG_CONST_STRING_085:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WORD_STRING) - Laenge in R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_087
        MOV        R16, R17
M_PRG_CONST_STRING_086:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_086
M_PRG_CONST_STRING_087:
        ST         -Z, R17
 
; PROCEDURE - Ende (WORDTOSTRING)
        RET
 
; FUNCTION - Anfang (STRINGTOWORD)
STRINGTOWORD:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_088
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_088:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_090
        MOV        R16, R17
M_PRG_CONST_STRING_089:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_089
M_PRG_CONST_STRING_090:
        ST         -Z, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_091
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_091:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_093
M_PRG_CONST_STRING_092:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_092
M_PRG_CONST_STRING_093:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_094
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_094:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_096
        MOV        R16, R17
M_PRG_CONST_STRING_095:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_095
M_PRG_CONST_STRING_096:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STRINGTOWORD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf Funktion (STRINGTOBYTE)
        CALL       STRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STRINGTOWORD)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R5, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(S2B)
        MOV        R16, R5
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (S2W)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0100)
        LDI        R18, LOW(0x0100)
        LDI        R19, HIGH(0x0100)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_097
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_097:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_099
        MOV        R16, R17
M_PRG_CONST_STRING_098:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_098
M_PRG_CONST_STRING_099:
        ST         -Z, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x04)
        LDI        R16, 0x04
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0100
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0100:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0102
M_PRG_CONST_STRING_0101:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0101
M_PRG_CONST_STRING_0102:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0103
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0103:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0105
        MOV        R16, R17
M_PRG_CONST_STRING_0104:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0104
M_PRG_CONST_STRING_0105:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STRINGTOWORD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf Funktion (STRINGTOBYTE)
        CALL       STRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STRINGTOWORD)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R5, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(S2B)
        MOV        R16, R5
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W2)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (S2W)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (S2W2)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; RESULT Word-Variable - FUNCTION (STRINGTOWORD)
        MOV        R0, R3
        MOV        R1, R4
 
; Ende Word - FUNCTION (STRINGTOWORD)
        MOV        R16, R0
        MOV        R17, R1
 
; FUNCTION - Ende (STRINGTOWORD)
        RET
 
; PROCEDURE - Anfang (DWORDTOSTRING)
DWORDTOSTRING:
 
; Zuweisung Quelle - Ausdruck / DWLow(WERT_DWORD)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WORD_LOW)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / DWHigh(WERT_DWORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WORD_HIGH)
        MOV        R6, R16
        MOV        R7, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (DWORDTOSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (WORD_HIGH) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (WORD_HIGH) an Prozedur (WORDTOSTRING)
        MOV        R0, R22
        MOV        R1, R23
 
; Aufruf PROCEDURE (WORDTOSTRING)
        CALL       WORDTOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (DWORDTOSTRING)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (DWORD_STRING)=8
        LDI        R16, 8
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0106
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0106:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0108
M_PRG_CONST_STRING_0107:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0107
M_PRG_CONST_STRING_0108:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (DWORD_STRING) - Laenge in R17
        LDI        ZL, LOW(DWORD_STRING)
        LDI        ZH, HIGH(DWORD_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0110
        MOV        R16, R17
M_PRG_CONST_STRING_0109:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0109
M_PRG_CONST_STRING_0110:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (DWORDTOSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (WORD_LOW) retten
        MOV        R20, R4
        MOV        R21, R5
 
; lokalen Parameter (WORD_LOW) an Prozedur (WORDTOSTRING)
        MOV        R0, R20
        MOV        R1, R21
 
; Aufruf PROCEDURE (WORDTOSTRING)
        CALL       WORDTOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (DWORDTOSTRING)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (DWORD_STRING)=8
        LDI        R16, 8
        CLR        R17
        LDI        ZL, LOW(DWORD_STRING)
        LDI        ZH, HIGH(DWORD_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0111
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0111:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0113
M_PRG_CONST_STRING_0112:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0112
M_PRG_CONST_STRING_0113:
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0114
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0114:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0116
M_PRG_CONST_STRING_0115:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0115
M_PRG_CONST_STRING_0116:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (DWORD_STRING) - Laenge in R17
        LDI        ZL, LOW(DWORD_STRING)
        LDI        ZH, HIGH(DWORD_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0118
        MOV        R16, R17
M_PRG_CONST_STRING_0117:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0117
M_PRG_CONST_STRING_0118:
        ST         -Z, R17
 
; PROCEDURE - Ende (DWORDTOSTRING)
        RET
 
; PROCEDURE - Anfang (INIT_SER0_PORT)
INIT_SER0_PORT:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (UBRR0H)
        STS        UBRR0H, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (UBRR_VAL)
        LDI        R16, 0x19
 
; Zuweisung Ziel /  VAR (UBRR0L)
        STS        UBRR0L, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x18)
        LDI        R16, 0x18
 
; Zuweisung Ziel /  VAR (UCSR0B)
        STS        UCSR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x86)
        LDI        R16, 0x86
 
; Zuweisung Ziel /  VAR (UCSR0C)
        STS        UCSR0C, R16
 
; PROCEDURE - Ende (INIT_SER0_PORT)
        RET
 
; PROCEDURE - Anfang (RX0_PUFFER_ABFRAGEN)
RX0_PUFFER_ABFRAGEN:
 
; IF THEN - Ausdruck /; BitHigh(RXC0)
        LDS        R16, UCSR0A
        BST        R16, 7
        BRTS       M_VERGL_0122
        CLR        R16
        RJMP       M_VERGL_0123
M_VERGL_0122:
        SER        R16
M_VERGL_0123:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0119
        RJMP       M_IF_0120
M_IF_0119:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (UDR0)
        LDS        R16, UDR0
 
; Zuweisung Ziel /  VAR (SER0_ZEICHEN)
        STS        SER0_ZEICHEN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0121
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0120:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SER0_ZEICHEN)
        STS        SER0_ZEICHEN, R16
 
; IF_THEN_ELSE - Ende
M_IF_0121:
 
; PROCEDURE - Ende (RX0_PUFFER_ABFRAGEN)
        RET
 
; PROCEDURE - Anfang (SENDE_ZEICHEN0)
SENDE_ZEICHEN0:
 
; WHILE DO ...
M_WHILE_0124:
 
; WHILE - Ausdruck /; BitLow(UDRE0)
        LDS        R16, UCSR0A
        BST        R16, 5
        BRTC       M_VERGL_0127
        CLR        R16
        RJMP       M_VERGL_0128
M_VERGL_0127:
        SER        R16
M_VERGL_0128:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0125
        RJMP       M_WHILE_0126
M_WHILE_0125:
 
; WHILE DO ...
        RJMP       M_WHILE_0124
M_WHILE_0126:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (S_ZEICHEN0)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (UDR0)
        STS        UDR0, R16
 
; PROCEDURE - Ende (SENDE_ZEICHEN0)
        RET
 
; PROCEDURE - Anfang (WRITE_SER0)
WRITE_SER0:
 
; Zuweisung Quelle - Ausdruck / Length(SER0_STRING)
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R1
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0129:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0130
        RJMP       M_FTD_0131
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0130:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (SER0_STRING)
        CLR        R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE_SER0)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (B2) retten
        MOV        R19, R3
 
; lokalen Parameter (B2) an Prozedur (SENDE_ZEICHEN0)
        MOV        R0, R19
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE_SER0)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0129
 
; FOR TO DO - Ende
M_FTD_0131:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (WRITE_SER0)
        RET
 
; PROCEDURE - Anfang (WRITELN_SER0)
WRITELN_SER0:
 
; Aufruf PROCEDURE (WRITE_SER0)
        CALL       WRITE_SER0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x0A
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; PROCEDURE - Ende (WRITELN_SER0)
        RET
 
; PROCEDURE - Anfang (ITP3_INIT)
ITP3_INIT:
 
; ClearBit(D0_D)
        CBI        DDRC, 0
 
; ClearBit(D1_D)
        CBI        DDRC, 1
 
; ClearBit(D2_D)
        CBI        DDRC, 2
 
; ClearBit(D3_D)
        CBI        DDRC, 3
 
; SetBit(DS0_A)
        SBI        PORTC, 4
 
; SetBit(DS0_D)
        SBI        DDRC, 4
 
; ClearBit(DR_D)
        CBI        DDRC, 5
 
; PROCEDURE - Ende (ITP3_INIT)
        RET
 
; PROCEDURE - Anfang (ITP3_SENDE_HALBBYTE)
ITP3_SENDE_HALBBYTE:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0135
        CLR        R16
        RJMP       M_VERGL_0136
M_VERGL_0135:
        SER        R16
M_VERGL_0136:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0132
        RJMP       M_IF_0133
M_IF_0132:
 
; ClearBit(D0_A)
        CBI        PORTC, 0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0134
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0133:
 
; SetBit(D0_A)
        SBI        PORTC, 0
 
; IF_THEN_ELSE - Ende
M_IF_0134:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0140
        CLR        R16
        RJMP       M_VERGL_0141
M_VERGL_0140:
        SER        R16
M_VERGL_0141:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0137
        RJMP       M_IF_0138
M_IF_0137:
 
; ClearBit(D1_A)
        CBI        PORTC, 1
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0139
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0138:
 
; SetBit(D1_A)
        SBI        PORTC, 1
 
; IF_THEN_ELSE - Ende
M_IF_0139:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0145
        CLR        R16
        RJMP       M_VERGL_0146
M_VERGL_0145:
        SER        R16
M_VERGL_0146:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0142
        RJMP       M_IF_0143
M_IF_0142:
 
; ClearBit(D2_A)
        CBI        PORTC, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0144
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0143:
 
; SetBit(D2_A)
        SBI        PORTC, 2
 
; IF_THEN_ELSE - Ende
M_IF_0144:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0150
        CLR        R16
        RJMP       M_VERGL_0151
M_VERGL_0150:
        SER        R16
M_VERGL_0151:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0147
        RJMP       M_IF_0148
M_IF_0147:
 
; ClearBit(D3_A)
        CBI        PORTC, 3
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0149
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0148:
 
; SetBit(D3_A)
        SBI        PORTC, 3
 
; IF_THEN_ELSE - Ende
M_IF_0149:
 
; ClearBit(DS0_A)
        CBI        PORTC, 4
 
; SetBit(LED_ROT)
        SBI        PORTB, 0
 
; WHILE DO ...
M_WHILE_0152:
 
; WHILE - Ausdruck /; BitHigh(DR_E)
        IN         R16, PINC
        BST        R16, 5
        BRTS       M_VERGL_0155
        CLR        R16
        RJMP       M_VERGL_0156
M_VERGL_0155:
        SER        R16
M_VERGL_0156:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0153
        RJMP       M_WHILE_0154
M_WHILE_0153:
 
; WHILE DO ...
        RJMP       M_WHILE_0152
M_WHILE_0154:
 
; ClearBit(LED_ROT)
        CBI        PORTB, 0
 
; SetBit(DS0_A)
        SBI        PORTC, 4
 
; SetBit(LED_GELB)
        SBI        PORTB, 1
 
; WHILE DO ...
M_WHILE_0157:
 
; WHILE - Ausdruck /; BitLow(DR_E)
        IN         R16, PINC
        BST        R16, 5
        BRTC       M_VERGL_0160
        CLR        R16
        RJMP       M_VERGL_0161
M_VERGL_0160:
        SER        R16
M_VERGL_0161:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0158
        RJMP       M_WHILE_0159
M_WHILE_0158:
 
; WHILE DO ...
        RJMP       M_WHILE_0157
M_WHILE_0159:
 
; ClearBit(LED_GELB)
        CBI        PORTB, 1
 
; PROCEDURE - Ende (ITP3_SENDE_HALBBYTE)
        RET
 
; PROCEDURE - Anfang (ITP3_SENDE_BYTE)
ITP3_SENDE_BYTE:
 
; SetBit(D0_D)
        SBI        DDRC, 0
 
; SetBit(D1_D)
        SBI        DDRC, 1
 
; SetBit(D2_D)
        SBI        DDRC, 2
 
; SetBit(D3_D)
        SBI        DDRC, 3
 
; SetBit(DS0_A)
        SBI        PORTC, 4
 
; SetBit(DS0_D)
        SBI        DDRC, 4
 
; ClearBit(DR_D)
        CBI        DDRC, 5
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_BYTE)
        PUSH       R0
        PUSH       R1
 
; Parameter (B1) retten
        MOV        R17, R1
 
; lokalen Parameter (B1) an Prozedur (ITP3_SENDE_HALBBYTE)
        MOV        R0, R17
 
; Aufruf PROCEDURE (ITP3_SENDE_HALBBYTE)
        CALL       ITP3_SENDE_HALBBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_BYTE)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; SHR(B1) - Byte
        LSR        R1
 
; SHR(B1) - Byte
        LSR        R1
 
; SHR(B1) - Byte
        LSR        R1
 
; SHR(B1) - Byte
        LSR        R1
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_BYTE)
        PUSH       R0
        PUSH       R1
 
; Parameter (B1) retten
        MOV        R17, R1
 
; lokalen Parameter (B1) an Prozedur (ITP3_SENDE_HALBBYTE)
        MOV        R0, R17
 
; Aufruf PROCEDURE (ITP3_SENDE_HALBBYTE)
        CALL       ITP3_SENDE_HALBBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_BYTE)
        POP        R1
        POP        R0
 
; ClearBit(D0_D)
        CBI        DDRC, 0
 
; ClearBit(D1_D)
        CBI        DDRC, 1
 
; ClearBit(D2_D)
        CBI        DDRC, 2
 
; ClearBit(D3_D)
        CBI        DDRC, 3
 
; PROCEDURE - Ende (ITP3_SENDE_BYTE)
        RET
 
; FUNCTION - Anfang (ITP3_EMPFANGE_HALBBYTE)
ITP3_EMPFANGE_HALBBYTE:
 
; ClearBit(DS0_A)
        CBI        PORTC, 4
 
; SetBit(LED_ROT)
        SBI        PORTB, 0
 
; WHILE DO ...
M_WHILE_0162:
 
; WHILE - Ausdruck /; BitHigh(DR_E)
        IN         R16, PINC
        BST        R16, 5
        BRTS       M_VERGL_0165
        CLR        R16
        RJMP       M_VERGL_0166
M_VERGL_0165:
        SER        R16
M_VERGL_0166:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0163
        RJMP       M_WHILE_0164
M_WHILE_0163:
 
; WHILE DO ...
        RJMP       M_WHILE_0162
M_WHILE_0164:
 
; ClearBit(LED_ROT)
        CBI        PORTB, 0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; IF THEN - Ausdruck /; BitHigh(D0_E)
        IN         R16, PINC
        BST        R16, 0
        BRTS       M_VERGL_0170
        CLR        R16
        RJMP       M_VERGL_0171
M_VERGL_0170:
        SER        R16
M_VERGL_0171:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0167
        RJMP       M_IF_0168
M_IF_0167:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0168:
 
; IF THEN - Ausdruck /; BitHigh(D1_E)
        IN         R16, PINC
        BST        R16, 1
        BRTS       M_VERGL_0175
        CLR        R16
        RJMP       M_VERGL_0176
M_VERGL_0175:
        SER        R16
M_VERGL_0176:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0172
        RJMP       M_IF_0173
M_IF_0172:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0173:
 
; IF THEN - Ausdruck /; BitHigh(D2_E)
        IN         R16, PINC
        BST        R16, 2
        BRTS       M_VERGL_0180
        CLR        R16
        RJMP       M_VERGL_0181
M_VERGL_0180:
        SER        R16
M_VERGL_0181:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0177
        RJMP       M_IF_0178
M_IF_0177:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0178:
 
; IF THEN - Ausdruck /; BitHigh(D3_E)
        IN         R16, PINC
        BST        R16, 3
        BRTS       M_VERGL_0185
        CLR        R16
        RJMP       M_VERGL_0186
M_VERGL_0185:
        SER        R16
M_VERGL_0186:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0182
        RJMP       M_IF_0183
M_IF_0182:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0183:
 
; SetBit(DS0_A)
        SBI        PORTC, 4
 
; SetBit(LED_GELB)
        SBI        PORTB, 1
 
; WHILE DO ...
M_WHILE_0187:
 
; WHILE - Ausdruck /; BitLow(DR_E)
        IN         R16, PINC
        BST        R16, 5
        BRTC       M_VERGL_0190
        CLR        R16
        RJMP       M_VERGL_0191
M_VERGL_0190:
        SER        R16
M_VERGL_0191:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0188
        RJMP       M_WHILE_0189
M_WHILE_0188:
 
; WHILE DO ...
        RJMP       M_WHILE_0187
M_WHILE_0189:
 
; ClearBit(LED_GELB)
        CBI        PORTB, 1
 
; RESULT Byte-Variable - FUNCTION (ITP3_EMPFANGE_HALBBYTE)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (ITP3_EMPFANGE_HALBBYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_EMPFANGE_HALBBYTE)
        RET
 
; FUNCTION - Anfang (ITP3_EMPFANGE_BYTE)
ITP3_EMPFANGE_BYTE:
 
; ClearBit(D0_D)
        CBI        DDRC, 0
 
; ClearBit(D1_D)
        CBI        DDRC, 1
 
; ClearBit(D2_D)
        CBI        DDRC, 2
 
; ClearBit(D3_D)
        CBI        DDRC, 3
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (ITP3_EMPFANGE_HALBBYTE)
        CALL       ITP3_EMPFANGE_HALBBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE_01)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (ITP3_EMPFANGE_HALBBYTE)
        CALL       ITP3_EMPFANGE_HALBBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE_02)
        MOV        R2, R16
 
; SHL(RESULT_BYTE_02) - Byte
        LSL        R2
 
; SHL(RESULT_BYTE_02) - Byte
        LSL        R2
 
; SHL(RESULT_BYTE_02) - Byte
        LSL        R2
 
; SHL(RESULT_BYTE_02) - Byte
        LSL        R2
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE_01)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (RESULT_BYTE_02)
        MOV        R18, R2
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE_01)
        MOV        R1, R16
 
; RESULT Byte-Variable - FUNCTION (ITP3_EMPFANGE_BYTE)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (ITP3_EMPFANGE_BYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_EMPFANGE_BYTE)
        RET
 
; PROCEDURE - Anfang (ITP3_SENDE_CONOUT)
ITP3_SENDE_CONOUT:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_CONOUT)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDI        R16, 0x03
        MOV        R0, R16
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_CONOUT)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_CONOUT)
        POP        R0
 
; PROCEDURE - Ende (ITP3_SENDE_CONOUT)
        RET
 
; FUNCTION - Anfang (ITP3_EMPFANGE_CONST)
ITP3_EMPFANGE_CONST:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_CONST)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_CONST)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_CONST)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (ITP3_EMPFANGE_BYTE)
        CALL       ITP3_EMPFANGE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_CONST)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; RESULT Byte-Variable - FUNCTION (ITP3_EMPFANGE_CONST)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (ITP3_EMPFANGE_CONST)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_EMPFANGE_CONST)
        RET
 
; FUNCTION - Anfang (ITP3_EMPFANGE_CONIN)
ITP3_EMPFANGE_CONIN:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_CONIN)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDI        R16, 0x05
        MOV        R0, R16
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_CONIN)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_CONIN)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (ITP3_EMPFANGE_BYTE)
        CALL       ITP3_EMPFANGE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_CONIN)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; RESULT Byte-Variable - FUNCTION (ITP3_EMPFANGE_CONIN)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (ITP3_EMPFANGE_CONIN)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_EMPFANGE_CONIN)
        RET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; PROCEDURE - Anfang (A1)
A1:
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_CONOUT)
        LDS        R0, SER0_ZEICHEN
 
; Aufruf PROCEDURE (ITP3_SENDE_CONOUT)
        CALL       ITP3_SENDE_CONOUT
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=20
        LDI        R16, 20
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('CONOUT')
        LDI        ZL, LOW(2*M_CONST_STRING_0)
        LDI        ZH, HIGH(2*M_CONST_STRING_0)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0192
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0192:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0194
M_PRG_CONST_STRING_0193:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0193
M_PRG_CONST_STRING_0194:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0196
        MOV        R16, R17
M_PRG_CONST_STRING_0195:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0195
M_PRG_CONST_STRING_0196:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; PROCEDURE - Ende (A1)
        RET
 
; PROCEDURE - Anfang (B1)
B1:
 
; Retten der lokalen Parameter fuer PROCEDURE (B1)
        PUSH       R0
 
; Aufruf Funktion (ITP3_EMPFANGE_CONST)
        CALL       ITP3_EMPFANGE_CONST
 
; Retten der Parameter-Register fuer PROCEDURE (B1)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (CI_BYTE)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (B1)
        PUSH       R0
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (B1)
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SER0_STRING)=20
        LDI        R16, 20
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('CONST=')
        LDI        ZL, LOW(2*M_CONST_STRING_1)
        LDI        ZH, HIGH(2*M_CONST_STRING_1)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0197
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0197:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0199
M_PRG_CONST_STRING_0198:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0198
M_PRG_CONST_STRING_0199:
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0200
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0200:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0202
M_PRG_CONST_STRING_0201:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0201
M_PRG_CONST_STRING_0202:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0204
        MOV        R16, R17
M_PRG_CONST_STRING_0203:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0203
M_PRG_CONST_STRING_0204:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (B1)
        PUSH       R0
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (B1)
        POP        R0
 
; PROCEDURE - Ende (B1)
        RET
 
; PROCEDURE - Anfang (C1)
C1:
 
; Retten der lokalen Parameter fuer PROCEDURE (C1)
        PUSH       R0
 
; Aufruf Funktion (ITP3_EMPFANGE_CONIN)
        CALL       ITP3_EMPFANGE_CONIN
 
; Retten der Parameter-Register fuer PROCEDURE (C1)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (CI_BYTE)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (C1)
        PUSH       R0
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (C1)
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SER0_STRING)=20
        LDI        R16, 20
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('CONIN=')
        LDI        ZL, LOW(2*M_CONST_STRING_2)
        LDI        ZH, HIGH(2*M_CONST_STRING_2)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0205
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0205:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0207
M_PRG_CONST_STRING_0206:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0206
M_PRG_CONST_STRING_0207:
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0208
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0208:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0210
M_PRG_CONST_STRING_0209:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0209
M_PRG_CONST_STRING_0210:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0212
        MOV        R16, R17
M_PRG_CONST_STRING_0211:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0211
M_PRG_CONST_STRING_0212:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (C1)
        PUSH       R0
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (C1)
        POP        R0
 
; PROCEDURE - Ende (C1)
        RET
 
; PROCEDURE - Anfang (AUSWERTUNG)
AUSWERTUNG:
 
; CASE OF - Byte-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; CASE OF - vergleiche Einzel-Element ($61)
        CPI        R16, 0x61
        BREQ       M_CASE_0215
        RJMP       M_CASE_0214
M_CASE_0215:
 
; Aufruf PROCEDURE (A1)
        CALL       A1
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0213
M_CASE_0214:
 
; CASE OF - vergleiche Einzel-Element ($62)
        CPI        R16, 0x62
        BREQ       M_CASE_0217
        RJMP       M_CASE_0216
M_CASE_0217:
 
; Aufruf PROCEDURE (B1)
        CALL       B1
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0213
M_CASE_0216:
 
; CASE OF - vergleiche Einzel-Element ($63)
        CPI        R16, 0x63
        BREQ       M_CASE_0219
        RJMP       M_CASE_0218
M_CASE_0219:
 
; Aufruf PROCEDURE (C1)
        CALL       C1
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0213
 
; CASE OF ELSE
M_CASE_0218:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=20
        LDI        R16, 20
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('*** Fehler')
        LDI        ZL, LOW(2*M_CONST_STRING_3)
        LDI        ZH, HIGH(2*M_CONST_STRING_3)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0220
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0220:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0222
M_PRG_CONST_STRING_0221:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0221
M_PRG_CONST_STRING_0222:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0224
        MOV        R16, R17
M_PRG_CONST_STRING_0223:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0223
M_PRG_CONST_STRING_0224:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; ENDCASE;
M_CASE_0213:
 
; PROCEDURE - Ende (AUSWERTUNG)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
 
; Aufruf PROCEDURE (INITPORTS)
        CALL       INITPORTS
 
; Aufruf PROCEDURE (INIT_SER0_PORT)
        CALL       INIT_SER0_PORT
 
; Aufruf PROCEDURE (ITP3_INIT)
        CALL       ITP3_INIT
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=20
        LDI        R16, 20
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('init o.k.')
        LDI        ZL, LOW(2*M_CONST_STRING_4)
        LDI        ZH, HIGH(2*M_CONST_STRING_4)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0225
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0225:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0227
M_PRG_CONST_STRING_0226:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0226
M_PRG_CONST_STRING_0227:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0229
        MOV        R16, R17
M_PRG_CONST_STRING_0228:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0228
M_PRG_CONST_STRING_0229:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; LOOP - Start_Marke
M_LOOP_0230:
 
; Aufruf PROCEDURE (RX0_PUFFER_ABFRAGEN)
        CALL       RX0_PUFFER_ABFRAGEN
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0234
        CLR        R16
        RJMP       M_VERGL_0235
M_VERGL_0234:
        SER        R16
M_VERGL_0235:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0231
        RJMP       M_IF_0232
M_IF_0231:
 
; Aufruf PROCEDURE (AUSWERTUNG)
        CALL       AUSWERTUNG
 
; IF_THEN - Ende
M_IF_0232:
 
; LOOP - Ende
        RJMP       M_LOOP_0230
 
; *** Unterprogramm Bibliothek ***
; Multiplikation von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17 erster Faktor
;            R18:R19 zweiter Faktor
; Temporaere Register: R20,R21,R22,R23,R24 
;                      R2 ,R3  R4  R5  R6
ASM_UP_MUL16:
 
        PUSH       R0
        PUSH       R1

        CLR        R24
        MUL        R19, R17
        MOVW       R23:R22, R1:R0
        MUL        R18, R16
        MOVW       R21:R20, R1:R0
        MUL        R19, R16
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MUL        R17, R18
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MOVW       R17:R16, R21:R20       ; Produkt Low
        MOVW       R19:R18, R23:R22       ; Produkt High

        POP        R1
        POP        R0		

        RET






 
; *** Namen-Liste ***
;
; UDR0 (V) BYTECONVAR
; UBRR0H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; TWAMR (V) BYTECONVAR
; TWCR (V) BYTECONVAR
; TWDR (V) BYTECONVAR
; TWAR (V) BYTECONVAR
; TWSR (V) BYTECONVAR
; TWBR (V) BYTECONVAR
; ASSR (V) BYTECONVAR
; OCR2B (V) BYTECONVAR
; OCR2A (V) BYTECONVAR
; TCNT2 (V) BYTECONVAR
; TCCR2B (V) BYTECONVAR
; TCCR2A (V) BYTECONVAR
; TIMSK2 (V) BYTECONVAR
; TIMSK1 (V) BYTECONVAR
; TIMSK0 (V) BYTECONVAR
; OCR1BL (V) BYTECONVAR
; OCR1BH (V) BYTECONVAR
; OCR1AH (V) BYTECONVAR
; OCR1AL (V) BYTECONVAR
; ICR1L (V) BYTECONVAR
; ICR1H (V) BYTECONVAR
; TCNT1L (V) BYTECONVAR
; TCNT1H (V) BYTECONVAR
; TCCR1C (V) BYTECONVAR
; TCCR1B (V) BYTECONVAR
; TCCR1A (V) BYTECONVAR
; DIDR1 (V) BYTECONVAR
; DIDR0 (V) BYTECONVAR
; ADMUX (V) BYTECONVAR
; ADCSRB (V) BYTECONVAR
; ADCSRA (V) BYTECONVAR
; ADCH (V) BYTECONVAR
; ADCL (V) BYTECONVAR
; PCMSK0 (V) BYTECONVAR
; PCMSK1 (V) BYTECONVAR
; PCMSK2 (V) BYTECONVAR
; PCMSK3 (V) BYTECONVAR
; EICRA (V) BYTECONVAR
; PCICR (V) BYTECONVAR
; OSCCAL (V) BYTECONVAR
; PRR0 (V) BYTECONVAR
; CLKPR (V) BYTECONVAR
; WDTCSR (V) BYTECONVAR
; SREG (V) BYTECONREG
; SPL (V) BYTECONREG
; SPH (V) BYTECONREG
; SPMCSR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; SMCR (V) BYTECONREG
; OCDR (V) BYTECONREG
; ACSR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; GPIOR0 (V) BYTECONREG
; GPIOR1 (V) BYTECONREG
; GPIOR2 (V) BYTECONREG
; OCR0A (V) BYTECONREG
; OCR0B (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; TCCR0A (V) BYTECONREG
; TCCR0B (V) BYTECONREG
; GTCCR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; EIMSK (V) BYTECONREG
; EIFR (V) BYTECONREG
; PCIFR (V) BYTECONREG
; TIFR2 (V) BYTECONREG
; TIFR1 (V) BYTECONREG
; TIFR0 (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; RXC0 (B) BIT
; TXC0 (B) BIT
; UDRE0 (B) BIT
; TAKTFREQUENZ (C) WORD Wert=0x3E80
; UBRR_VAL (C) BYTE Wert=0x19
; LED_ROT (B) BIT
; LED_GELB (B) BIT
; LED_GRUEN (B) BIT
; WAITKON (C) WORD Wert=0x0010
; WAITKON2 (C) WORD Wert=0x02D0
; BYTE_STRING (V) STRING
; WORD_STRING (V) STRING
; DWORD_STRING (V) STRING
; BYTEPOSTOORMASKE (F) 
; BYTEPOSTOANDMASKE (F) 
; READ_BIT_IN_BYTE (F) 
; SET_BIT_IN_BYTE (F) 
; CLEAR_BIT_IN_BYTE (F) 
; NEGATION_BYTE (F) 
; WAIT_MS (P) 
; BYTETOSTRING (P) 
; STRINGTOBYTE (F) 
; WORDTOSTRING (P) 
; STRINGTOWORD (F) 
; DWORDTOSTRING (P) 
; SER0_ZEICHEN (V) BYTE
; SER0_STRING (V) STRING
; INIT_SER0_PORT (P) 
; RX0_PUFFER_ABFRAGEN (P) 
; SENDE_ZEICHEN0 (P) 
; WRITE_SER0 (P) 
; WRITELN_SER0 (P) 
; D0_A (B) BIT
; D1_A (B) BIT
; D2_A (B) BIT
; D3_A (B) BIT
; DR_A (B) BIT
; D0_D (B) BIT
; D1_D (B) BIT
; D2_D (B) BIT
; D3_D (B) BIT
; DR_D (B) BIT
; D0_E (B) BIT
; D1_E (B) BIT
; D2_E (B) BIT
; D3_E (B) BIT
; DR_E (B) BIT
; DS0_A (B) BIT
; DS0_D (B) BIT
; DS0_E (B) BIT
; ITP3_STRING (V) STRING
; ITP3_WHO_AM_I (C) BYTE Wert=0x01
; ITP3_ERROR_CODE (C) BYTE Wert=0x02
; ITP3_CONOUT (C) BYTE Wert=0x03
; ITP3_CONST (C) BYTE Wert=0x04
; ITP3_CONIN (C) BYTE Wert=0x05
; ITP3_INIT (P) 
; ITP3_SENDE_HALBBYTE (P) 
; ITP3_SENDE_BYTE (P) 
; ITP3_EMPFANGE_HALBBYTE (F) 
; ITP3_EMPFANGE_BYTE (F) 
; ITP3_SENDE_CONOUT (P) 
; ITP3_EMPFANGE_CONST (F) 
; ITP3_EMPFANGE_CONIN (F) 
; INITPORTS (P) 
; A1 (P) 
; B1 (P) 
; C1 (P) 
; AUSWERTUNG (P) 
 
; *** Prozedur/Function-Liste ***
;
; FUNCTION BYTEPOSTOORMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION BYTEPOSTOANDMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION READ_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (VERGLEICH : BYTE) (MASKE : BYTE) : BOOLEAN;
; FUNCTION SET_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION CLEAR_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION NEGATION_BYTE (DAS_BYTE : BYTE) : BYTE;
; PROCEDURE WAIT_MS (ZEIT : WORD) (W1 : WORD) (W2 : WORD);
; PROCEDURE BYTETOSTRING (WERT_BYTE : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE) (C1 : CHAR);
; FUNCTION STRINGTOBYTE (HEXLOW : BYTE) (HEXHIGH : BYTE) (S2B : BYTE) (C1 : CHAR) : BYTE;
; PROCEDURE WORDTOSTRING (WERT_WORD : WORD) (BYTE_LOW : BYTE) (BYTE_HIGH : BYTE);
; FUNCTION STRINGTOWORD (C1 : CHAR) (S2W : WORD) (S2B : BYTE) (S2W2 : WORD) : WORD;
; PROCEDURE DWORDTOSTRING (WERT_DWORD : DWORD) (WORD_LOW : WORD) (WORD_HIGH : WORD);
; PROCEDURE INIT_SER0_PORT;
; PROCEDURE RX0_PUFFER_ABFRAGEN;
; PROCEDURE SENDE_ZEICHEN0 (S_ZEICHEN0 : BYTE);
; PROCEDURE WRITE_SER0 (C1 : CHAR) (LAENGE : BYTE) (B1 : BYTE) (B2 : BYTE);
; PROCEDURE WRITELN_SER0;
; PROCEDURE ITP3_INIT;
; PROCEDURE ITP3_SENDE_HALBBYTE (SB : BYTE) (B1 : BYTE);
; PROCEDURE ITP3_SENDE_BYTE (SB : BYTE) (B1 : BYTE);
; FUNCTION ITP3_EMPFANGE_HALBBYTE (RESULT_BYTE : BYTE) : BYTE;
; FUNCTION ITP3_EMPFANGE_BYTE (RESULT_BYTE_01 : BYTE) (RESULT_BYTE_02 : BYTE) : BYTE;
; PROCEDURE ITP3_SENDE_CONOUT (CO_BYTE : BYTE);
; FUNCTION ITP3_EMPFANGE_CONST (RESULT_BYTE : BYTE) : BYTE;
; FUNCTION ITP3_EMPFANGE_CONIN (RESULT_BYTE : BYTE) : BYTE;
; PROCEDURE INITPORTS;
; PROCEDURE A1;
; PROCEDURE B1 (CI_BYTE : BYTE);
; PROCEDURE C1 (CI_BYTE : BYTE);
; PROCEDURE AUSWERTUNG;
 
; *** Konstanten-STRING-Liste ***
;
 
M_CONST_STRING_0:
 .db    6, "CONOUT "
 
M_CONST_STRING_1:
 .db    6, "CONST= "
 
M_CONST_STRING_2:
 .db    6, "CONIN= "
 
M_CONST_STRING_3:
 .db    10, "*** Fehler "
 
M_CONST_STRING_4:
 .db    9, "init o.k."
 
