
// ****************************
// *** ITP3-Client-Routinen ***
// *** Hardwareteil         ***
// ****************************



VAR

{
C0..C3 - D0..D3 - ITP3-Daten
C4 - DS - Device Select
C5 - DR - Device Receive
}
  // Ausgangs-Definitionen
  D0_A[PortC,0] : bit; // D0 - Ausgang
  D1_A[PortC,1] : bit; // D1 - Ausgang
  D2_A[PortC,2] : bit; // D2 - Ausgang
  D3_A[PortC,3] : bit; // D3 - Ausgang
  DR_A[PortD,5] : bit; // DR - Device Receive - Ausgang

  // Port-Richtungs-Definitionen (E/A)
  D0_D[DDRC,0] : bit;  // D0 - Ein-/Ausgang (Direction)
  D1_D[DDRC,1] : bit;  // D1 - Ein-/Ausgang (Direction)
  D2_D[DDRC,2] : bit;  // D2 - Ein-/Ausgang (Direction)
  D3_D[DDRC,3] : bit;  // D3 - Ein-/Ausgang (Direction)
  DR_D[DDRD,5] : bit;  // DR - Device Receive (Direction)

  // Eingangs-Definitionen
  D0_E[PinC,0] : bit;  // D0 - Eingang
  D1_E[PinC,1] : bit;  // D1 - Eingang
  D2_E[PinC,2] : bit;  // D2 - Eingang
  D3_E[PinC,3] : bit;  // D3 - Eingang
  DR_E[PinD,5] : bit;  // DR - Device Receive - Eingang



  // DS fuer Client 1
  DS_A[PortD,4] : bit; // DS - Device Select - Ausgang
  DS_D[DDRD,4] : bit;  // DS - Device Select (Direction)
  DS_E[PinD,4] : bit;  // DS - Device Select - Eingang







