; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TST01.PAS
 
.nolist
.INCLUDE "m328Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        TAKTFREQUENZ  =  0x1F40 ; WORD
.equ        WAITKON  =  0x0008 ; WORD
.equ        WAITKON2  =  0x0168 ; WORD
.equ        ITP3_WHO_AM_I  =  0x01 ; BYTE
.equ        ITP3_ERROR_CODE  =  0x02 ; BYTE
.equ        ITP3_CONOUT  =  0x03 ; BYTE
.equ        ITP3_CONST  =  0x04 ; BYTE
.equ        ITP3_CONIN  =  0x05 ; BYTE
 
; *** Variablentabelle ***
 
.dseg
 
DBG_ANFANG_VAR_TABELLE:
 
STATUS_LED_GELB:   ; Boolean
.byte     1
STATUS_LED_GRUEN:   ; Boolean
.byte     1
STATUS_LED_ROT_L:   ; Boolean
.byte     1
STATUS_LED_ROT_R:   ; Boolean
.byte     1
BYTE_STRING:   ; String(2)
.byte     1     ; STRING-Laenge
.byte     2
WORD_STRING:   ; String(4)
.byte     1     ; STRING-Laenge
.byte     4
DWORD_STRING:   ; String(8)
.byte     1     ; STRING-Laenge
.byte     8
WD_WORD:   ; Word
.byte     2
KEYBUFFERPTR:   ; Word
.byte     2
TASTEN_NUMMER:   ; Byte
.byte     1
LETZTE_TASTEN_NUMMER:   ; Byte
.byte     1
ENTPRELL_ZAEHLER:   ; Byte
.byte     1
TEXT_STRING:   ; String(15)
.byte     1     ; STRING-Laenge
.byte     15
SHIFT_IST_AKTIV:   ; Boolean
.byte     1
CTRL_IST_AKTIV:   ; Boolean
.byte     1
 
KEYBUFFER:
.byte     33
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; FUNCTION - Anfang (BYTEPOSTOORMASKE)
BYTEPOSTOORMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_03
        RJMP       M_CASE_02
M_CASE_03:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_02:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_05
        RJMP       M_CASE_04
M_CASE_05:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x02
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_04:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_07
        RJMP       M_CASE_06
M_CASE_07:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x04
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_06:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_09
        RJMP       M_CASE_08
M_CASE_09:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x08
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_08:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_011
        RJMP       M_CASE_010
M_CASE_011:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x10
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_010:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_013
        RJMP       M_CASE_012
M_CASE_013:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x20
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_012:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_015
        RJMP       M_CASE_014
M_CASE_015:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x40
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_014:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_017
        RJMP       M_CASE_016
M_CASE_017:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x80
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
 
; CASE OF ELSE
M_CASE_016:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; ENDCASE;
M_CASE_01:
 
; Ende Byte - FUNCTION (BYTEPOSTOORMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOORMASKE)
        RET
 
; FUNCTION - Anfang (BYTEPOSTOANDMASKE)
BYTEPOSTOANDMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_020
        RJMP       M_CASE_019
M_CASE_020:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_019:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_022
        RJMP       M_CASE_021
M_CASE_022:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFD
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_021:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_024
        RJMP       M_CASE_023
M_CASE_024:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFB
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_023:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_026
        RJMP       M_CASE_025
M_CASE_026:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xF7
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_025:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_028
        RJMP       M_CASE_027
M_CASE_028:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xEF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_027:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_030
        RJMP       M_CASE_029
M_CASE_030:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xDF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_029:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_032
        RJMP       M_CASE_031
M_CASE_032:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xBF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_031:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_034
        RJMP       M_CASE_033
M_CASE_034:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0x7F
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
 
; CASE OF ELSE
M_CASE_033:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; ENDCASE;
M_CASE_018:
 
; Ende Byte - FUNCTION (BYTEPOSTOANDMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOANDMASKE)
        RET
 
; FUNCTION - Anfang (READ_BIT_IN_BYTE)
READ_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (READ_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (READ_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_038
        CLR        R16
        RJMP       M_VERGL_039
M_VERGL_038:
        SER        R16
M_VERGL_039:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_035
        RJMP       M_IF_036
M_IF_035:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0x00
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_037
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_036:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0xFF
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_037:
 
; Ende Byte - FUNCTION (READ_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (READ_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (SET_BIT_IN_BYTE)
SET_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (SET_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (SET_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (CLEAR_BIT_IN_BYTE)
CLEAR_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOANDMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOANDMASKE)
        CALL       BYTEPOSTOANDMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (CLEAR_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (NEGATION_BYTE)
NEGATION_BYTE:
 
; ASM
    COM    R0
 
 
; RESULT Byte-Variable - FUNCTION (NEGATION_BYTE)
        MOV        R1, R0
 
; Ende Byte - FUNCTION (NEGATION_BYTE)
        MOV        R16, R1
 
; FUNCTION - Ende (NEGATION_BYTE)
        RET
 
; PROCEDURE - Anfang (WAIT_MS)
WAIT_MS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (ZEIT)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_040:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_041
        RJMP       M_FTD_042
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_041:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (WAITKON2)
        LDI        R16, LOW(0x0168)
        LDI        R17, HIGH(0x0168)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_043:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_044
        RJMP       M_FTD_045
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_044:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_043
 
; FOR TO DO - Ende
M_FTD_045:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_040
 
; FOR TO DO - Ende
M_FTD_042:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (WAIT_MS)
        RET
 
; PROCEDURE - Anfang (BYTETOSTRING)
BYTETOSTRING:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_049
        CLR        R16
        RJMP       M_VERGL_050
M_VERGL_049:
        SER        R16
M_VERGL_050:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_046
        RJMP       M_IF_047
M_IF_046:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_048
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_047:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_048:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_051
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_051:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_053
        MOV        R16, R17
M_PRG_CONST_STRING_052:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_052
M_PRG_CONST_STRING_053:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_057
        CLR        R16
        RJMP       M_VERGL_058
M_VERGL_057:
        SER        R16
M_VERGL_058:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_054
        RJMP       M_IF_055
M_IF_054:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_056
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_055:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_056:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXLOW)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_059
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_059:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_061
M_PRG_CONST_STRING_060:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_060
M_PRG_CONST_STRING_061:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_062
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_062:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_064
        MOV        R16, R17
M_PRG_CONST_STRING_063:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_063
M_PRG_CONST_STRING_064:
        ST         -Z, R17
 
; PROCEDURE - Ende (BYTETOSTRING)
        RET
 
; FUNCTION - Anfang (STRINGTOBYTE)
STRINGTOBYTE:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (BYTE_STRING)
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_068
        CLR        R16
        RJMP       M_VERGL_069
M_VERGL_068:
        SER        R16
M_VERGL_069:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_065
        RJMP       M_IF_066
M_IF_065:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN - Ende
M_IF_066:
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (BYTE_STRING)
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_073
        CLR        R16
        RJMP       M_VERGL_074
M_VERGL_073:
        SER        R16
M_VERGL_074:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_070
        RJMP       M_IF_071
M_IF_070:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_071:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (STRINGTOBYTE)
        MOV        R0, R3
 
; Ende Byte - FUNCTION (STRINGTOBYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (STRINGTOBYTE)
        RET
 
; PROCEDURE - Anfang (WORDTOSTRING)
WORDTOSTRING:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(WERT_WORD)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BYTE_LOW)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(WERT_WORD)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BYTE_HIGH)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WORDTOSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (BYTE_HIGH) retten
        MOV        R19, R3
 
; lokalen Parameter (BYTE_HIGH) an Prozedur (BYTETOSTRING)
        MOV        R0, R19
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (WORDTOSTRING)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WORD_STRING)=4
        LDI        R16, 4
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_075
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_075:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_077
M_PRG_CONST_STRING_076:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_076
M_PRG_CONST_STRING_077:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WORD_STRING) - Laenge in R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_079
        MOV        R16, R17
M_PRG_CONST_STRING_078:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_078
M_PRG_CONST_STRING_079:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (WORDTOSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (BYTE_LOW) retten
        MOV        R18, R2
 
; lokalen Parameter (BYTE_LOW) an Prozedur (BYTETOSTRING)
        MOV        R0, R18
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (WORDTOSTRING)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WORD_STRING)=4
        LDI        R16, 4
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_080
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_080:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_082
M_PRG_CONST_STRING_081:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_081
M_PRG_CONST_STRING_082:
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_083
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_083:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_085
M_PRG_CONST_STRING_084:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_084
M_PRG_CONST_STRING_085:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WORD_STRING) - Laenge in R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_087
        MOV        R16, R17
M_PRG_CONST_STRING_086:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_086
M_PRG_CONST_STRING_087:
        ST         -Z, R17
 
; PROCEDURE - Ende (WORDTOSTRING)
        RET
 
; FUNCTION - Anfang (STRINGTOWORD)
STRINGTOWORD:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_088
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_088:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_090
        MOV        R16, R17
M_PRG_CONST_STRING_089:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_089
M_PRG_CONST_STRING_090:
        ST         -Z, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_091
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_091:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_093
M_PRG_CONST_STRING_092:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_092
M_PRG_CONST_STRING_093:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_094
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_094:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_096
        MOV        R16, R17
M_PRG_CONST_STRING_095:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_095
M_PRG_CONST_STRING_096:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STRINGTOWORD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf Funktion (STRINGTOBYTE)
        CALL       STRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STRINGTOWORD)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R5, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(S2B)
        MOV        R16, R5
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (S2W)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0100)
        LDI        R18, LOW(0x0100)
        LDI        R19, HIGH(0x0100)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_097
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_097:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_099
        MOV        R16, R17
M_PRG_CONST_STRING_098:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_098
M_PRG_CONST_STRING_099:
        ST         -Z, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x04)
        LDI        R16, 0x04
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0100
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0100:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0102
M_PRG_CONST_STRING_0101:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0101
M_PRG_CONST_STRING_0102:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0103
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0103:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0105
        MOV        R16, R17
M_PRG_CONST_STRING_0104:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0104
M_PRG_CONST_STRING_0105:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STRINGTOWORD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf Funktion (STRINGTOBYTE)
        CALL       STRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STRINGTOWORD)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R5, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(S2B)
        MOV        R16, R5
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W2)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (S2W)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (S2W2)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; RESULT Word-Variable - FUNCTION (STRINGTOWORD)
        MOV        R0, R3
        MOV        R1, R4
 
; Ende Word - FUNCTION (STRINGTOWORD)
        MOV        R16, R0
        MOV        R17, R1
 
; FUNCTION - Ende (STRINGTOWORD)
        RET
 
; PROCEDURE - Anfang (DWORDTOSTRING)
DWORDTOSTRING:
 
; Zuweisung Quelle - Ausdruck / DWLow(WERT_DWORD)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WORD_LOW)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / DWHigh(WERT_DWORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WORD_HIGH)
        MOV        R6, R16
        MOV        R7, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (DWORDTOSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (WORD_HIGH) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (WORD_HIGH) an Prozedur (WORDTOSTRING)
        MOV        R0, R22
        MOV        R1, R23
 
; Aufruf PROCEDURE (WORDTOSTRING)
        CALL       WORDTOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (DWORDTOSTRING)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (DWORD_STRING)=8
        LDI        R16, 8
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0106
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0106:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0108
M_PRG_CONST_STRING_0107:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0107
M_PRG_CONST_STRING_0108:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (DWORD_STRING) - Laenge in R17
        LDI        ZL, LOW(DWORD_STRING)
        LDI        ZH, HIGH(DWORD_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0110
        MOV        R16, R17
M_PRG_CONST_STRING_0109:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0109
M_PRG_CONST_STRING_0110:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (DWORDTOSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (WORD_LOW) retten
        MOV        R20, R4
        MOV        R21, R5
 
; lokalen Parameter (WORD_LOW) an Prozedur (WORDTOSTRING)
        MOV        R0, R20
        MOV        R1, R21
 
; Aufruf PROCEDURE (WORDTOSTRING)
        CALL       WORDTOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (DWORDTOSTRING)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (DWORD_STRING)=8
        LDI        R16, 8
        CLR        R17
        LDI        ZL, LOW(DWORD_STRING)
        LDI        ZH, HIGH(DWORD_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0111
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0111:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0113
M_PRG_CONST_STRING_0112:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0112
M_PRG_CONST_STRING_0113:
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0114
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0114:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0116
M_PRG_CONST_STRING_0115:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0115
M_PRG_CONST_STRING_0116:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (DWORD_STRING) - Laenge in R17
        LDI        ZL, LOW(DWORD_STRING)
        LDI        ZH, HIGH(DWORD_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0118
        MOV        R16, R17
M_PRG_CONST_STRING_0117:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0117
M_PRG_CONST_STRING_0118:
        ST         -Z, R17
 
; PROCEDURE - Ende (DWORDTOSTRING)
        RET
 
; PROCEDURE - Anfang (TON_SIRENE)
TON_SIRENE:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (DAUER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FREQUENZ)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0119:
 
; FOR TO DO - Word-Vergleichsteil (DOWNTO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R18, R16
        CPC        R19, R17
        BRCC       M_FTD_0120
        RJMP       M_FTD_0121
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0120:
 
; SetBit(LSP_D0)
        SBI        PORTB, 0
 
; SetBit(LSP_D1)
        SBI        PORTB, 1
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_SIRENE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (FREQUENZ) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (FREQUENZ) an Prozedur (WAIT_MS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_SIRENE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ClearBit(LSP_D0)
        CBI        PORTB, 0
 
; ClearBit(LSP_D1)
        CBI        PORTB, 1
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_SIRENE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (FREQUENZ) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (FREQUENZ) an Prozedur (WAIT_MS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_SIRENE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-DEC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        SUB        R18, R20
        CLR        R20
        SBC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0119
 
; FOR TO DO - Ende
M_FTD_0121:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FREQUENZ)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (DAUER)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0122:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0123
        RJMP       M_FTD_0124
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0123:
 
; SetBit(LSP_D0)
        SBI        PORTB, 0
 
; SetBit(LSP_D1)
        SBI        PORTB, 1
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_SIRENE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (FREQUENZ) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (FREQUENZ) an Prozedur (WAIT_MS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_SIRENE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ClearBit(LSP_D0)
        CBI        PORTB, 0
 
; ClearBit(LSP_D1)
        CBI        PORTB, 1
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_SIRENE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (FREQUENZ) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (FREQUENZ) an Prozedur (WAIT_MS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_SIRENE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0122
 
; FOR TO DO - Ende
M_FTD_0124:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (TON_SIRENE)
        RET
 
; PROCEDURE - Anfang (CLICK)
CLICK:
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x0001)
        MOV        R0, R16
        LDI        R17, HIGH(0x0001)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; PROCEDURE - Ende (CLICK)
        RET
 
; PROCEDURE - Anfang (KBD_INIT)
KBD_INIT:
 
; ClearBit(SERIAL_DATA)
        CBI        PORTB, 2
 
; ClearBit(SHIFT_CLOCK)
        CBI        PORTD, 6
 
; ClearBit(LATCH_CLOCK)
        CBI        PORTD, 7
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (STATUS_LED_GELB)
        STS        STATUS_LED_GELB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (STATUS_LED_GRUEN)
        STS        STATUS_LED_GRUEN, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (STATUS_LED_ROT_L)
        STS        STATUS_LED_ROT_L, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (STATUS_LED_ROT_R)
        STS        STATUS_LED_ROT_R, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KEYBUFFERPTR)
        STS        KEYBUFFERPTR, R16
        STS        KEYBUFFERPTR+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x30)
        LDI        R16, 0x30
 
; Zuweisung Ziel /  VAR (LETZTE_TASTEN_NUMMER)
        STS        LETZTE_TASTEN_NUMMER, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SHIFT_IST_AKTIV)
        STS        SHIFT_IST_AKTIV, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CTRL_IST_AKTIV)
        STS        CTRL_IST_AKTIV, R16
 
; PROCEDURE - Ende (KBD_INIT)
        RET
 
; FUNCTION - Anfang (READ_KEY)
READ_KEY:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0128
        CLR        R16
        RJMP       M_VERGL_0129
M_VERGL_0128:
        SER        R16
M_VERGL_0129:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0125
        RJMP       M_IF_0126
M_IF_0125:
 
; ARRAY - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (KEYBUFFER)
        LDI        ZL, LOW(KEYBUFFER)
        LDI        ZH, HIGH(KEYBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (READ_KEY_VALUE)
        MOV        R1, R16
 
; DEC(KEYBUFFERPTR) - Word
        LDS        R24, KEYBUFFERPTR
        LDS        R25, KEYBUFFERPTR+1
        SBIW       R25:R24, 1
        STS        KEYBUFFERPTR, R24
        STS        KEYBUFFERPTR+1, R25
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KEY_COUNTER)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0130:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0131
        RJMP       M_FTD_0132
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0131:
 
; ARRAY - Ausdruck erster Faktor / lokale, dynamische Variable VAR (KEY_COUNTER)
        MOV        R16, R2
        MOV        R17, R3
 
; ARRAY - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (KEYBUFFER)
        LDI        ZL, LOW(KEYBUFFER)
        LDI        ZH, HIGH(KEYBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R4, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (KEY_COUNTER)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (KEYBUFFER)
        LDI        ZL, LOW(KEYBUFFER)
        LDI        ZH, HIGH(KEYBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR ARRAY-1D (KEYBUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0130
 
; FOR TO DO - Ende
M_FTD_0132:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0127
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0126:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (READ_KEY_VALUE)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_0127:
 
; RESULT Byte-Variable - FUNCTION (READ_KEY)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (READ_KEY)
        MOV        R16, R0
 
; FUNCTION - Ende (READ_KEY)
        RET
 
; PROCEDURE - Anfang (WRITE_KEY)
WRITE_KEY:
 
; VAR ARRAY-1D POSITION - Ausdruck / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; VAR ARRAY Ziel Zeiger berechnen (KEYBUFFER)
        LDI        ZL, LOW(KEYBUFFER)
        LDI        ZH, HIGH(KEYBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (WRITE_KEY_VALUE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR ARRAY-1D (KEYBUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0020)
        LDI        R18, LOW(0x0020)
        LDI        R19, HIGH(0x0020)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0136
        CLR        R16
        RJMP       M_VERGL_0137
M_VERGL_0136:
        SER        R16
M_VERGL_0137:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0133
        RJMP       M_IF_0134
M_IF_0133:
 
; INC(KEYBUFFERPTR) - Word
        LDS        R24, KEYBUFFERPTR
        LDS        R25, KEYBUFFERPTR+1
        ADIW       R25:R24, 1
        STS        KEYBUFFERPTR, R24
        STS        KEYBUFFERPTR+1, R25
 
; IF_THEN - Ende
M_IF_0134:
 
; PROCEDURE - Ende (WRITE_KEY)
        RET
 
; PROCEDURE - Anfang (WRITE_C_KEY)
WRITE_C_KEY:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(CKEY)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE_C_KEY)
        PUSH       R0
        PUSH       R1
 
; Parameter (B1) retten
        MOV        R17, R1
 
; lokalen Parameter (B1) an Prozedur (WRITE_KEY)
        MOV        R0, R17
 
; Aufruf PROCEDURE (WRITE_KEY)
        CALL       WRITE_KEY
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE_C_KEY)
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (WRITE_C_KEY)
        RET
 
; PROCEDURE - Anfang (WRITE_TEXT)
WRITE_TEXT:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZAEHLER)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Length(TEXT_STRING)
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        LD         R16, Z
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0138:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0139
        RJMP       M_FTD_0140
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0139:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ZAEHLER)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (TEXT_STRING)
        CLR        R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE_TEXT)
        PUSH       R0
        PUSH       R1
 
; Parameter (C1) retten
        MOV        R17, R1
 
; lokalen Parameter (C1) an Prozedur (WRITE_C_KEY)
        MOV        R0, R17
 
; Aufruf PROCEDURE (WRITE_C_KEY)
        CALL       WRITE_C_KEY
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE_TEXT)
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0138
 
; FOR TO DO - Ende
M_FTD_0140:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (WRITE_TEXT)
        RET
 
; PROCEDURE - Anfang (WRITE_DATA_WORD)
WRITE_DATA_WORD:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (R_COUNTER)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x10)
        LDI        R16, 0x10
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0141:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0142
        RJMP       M_FTD_0143
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0142:
 
; ClearBit(SHIFT_CLOCK)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (WD_WORD)
        LDS        R16, WD_WORD
        LDS        R17, WD_WORD+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator AND
        AND        R16, R18
        AND        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (R_WORD_LATCH)
        MOV        R0, R16
        MOV        R1, R17
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (R_WORD_LATCH)
        MOV        R16, R0
        MOV        R17, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0147
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0148
M_VERGL_0147:
        SER        R16
M_VERGL_0148:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0144
        RJMP       M_IF_0145
M_IF_0144:
 
; ClearBit(SERIAL_DATA)
        CBI        PORTB, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0146
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0145:
 
; SetBit(SERIAL_DATA)
        SBI        PORTB, 2
 
; IF_THEN_ELSE - Ende
M_IF_0146:
 
; SetBit(SHIFT_CLOCK)
        SBI        PORTD, 6
 
; SHR(WD_WORD) - Word
        LDS        R16, WD_WORD
        LDS        R17, WD_WORD+1
        LSR        R17
        ROR        R16
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0141
 
; FOR TO DO - Ende
M_FTD_0143:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; SetBit(LATCH_CLOCK)
        SBI        PORTD, 7
 
; ClearBit(LATCH_CLOCK)
        CBI        PORTD, 7
 
; PROCEDURE - Ende (WRITE_DATA_WORD)
        RET
 
; PROCEDURE - Anfang (TASTENNUMMER_ZU_TASTENZEICHEN)
TASTENNUMMER_ZU_TASTENZEICHEN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TASTEN_ZEICHEN)
        MOV        R0, R16
 
; CASE OF - Byte-VAR (TASTEN_NUMMER)
        LDS        R16, TASTEN_NUMMER
 
; CASE OF - vergleiche Einzel-Element (10)
        CPI        R16, 0x0A
        BREQ       M_CASE_0151
        RJMP       M_CASE_0150
M_CASE_0151:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (SHIFT_IST_AKTIV)
        STS        SHIFT_IST_AKTIV, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (STATUS_LED_GRUEN)
        STS        STATUS_LED_GRUEN, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0149
M_CASE_0150:
 
; CASE OF - vergleiche Einzel-Element (11)
        CPI        R16, 0x0B
        BREQ       M_CASE_0153
        RJMP       M_CASE_0152
M_CASE_0153:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (CTRL_IST_AKTIV)
        STS        CTRL_IST_AKTIV, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (STATUS_LED_ROT_L)
        STS        STATUS_LED_ROT_L, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (STATUS_LED_ROT_R)
        STS        STATUS_LED_ROT_R, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0149
 
; CASE OF ELSE
M_CASE_0152:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(TASTEN_NUMMER)
        LDS        R16, TASTEN_NUMMER
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TN_WORD)
        MOV        R1, R16
        MOV        R2, R17
 
; IF THEN - Ausdruck / Byte-VAR (SHIFT_IST_AKTIV)
        LDS        R16, SHIFT_IST_AKTIV
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0154
        RJMP       M_IF_0155
M_IF_0154:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (TN_WORD)
        MOV        R16, R1
        MOV        R17, R2
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (TASTENTABELLE_SHIFT)
        LDI        ZL, LOW(2*TASTENTABELLE_SHIFT)
        LDI        ZH, HIGH(2*TASTENTABELLE_SHIFT)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TASTEN_ZEICHEN)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SHIFT_IST_AKTIV)
        STS        SHIFT_IST_AKTIV, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (STATUS_LED_GRUEN)
        STS        STATUS_LED_GRUEN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0156
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0155:
 
; IF THEN - Ausdruck / Byte-VAR (CTRL_IST_AKTIV)
        LDS        R16, CTRL_IST_AKTIV
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0157
        RJMP       M_IF_0158
M_IF_0157:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (TN_WORD)
        MOV        R16, R1
        MOV        R17, R2
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (TASTENTABELLE_CTRL)
        LDI        ZL, LOW(2*TASTENTABELLE_CTRL)
        LDI        ZH, HIGH(2*TASTENTABELLE_CTRL)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TASTEN_ZEICHEN)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CTRL_IST_AKTIV)
        STS        CTRL_IST_AKTIV, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (STATUS_LED_ROT_L)
        STS        STATUS_LED_ROT_L, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (STATUS_LED_ROT_R)
        STS        STATUS_LED_ROT_R, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0159
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0158:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (TN_WORD)
        MOV        R16, R1
        MOV        R17, R2
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (TASTENTABELLE_NORMAL)
        LDI        ZL, LOW(2*TASTENTABELLE_NORMAL)
        LDI        ZH, HIGH(2*TASTENTABELLE_NORMAL)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TASTEN_ZEICHEN)
        MOV        R0, R16
 
; IF_THEN_ELSE - Ende
M_IF_0159:
 
; IF_THEN_ELSE - Ende
M_IF_0156:
 
; ENDCASE;
M_CASE_0149:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TASTEN_ZEICHEN)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0163
        CLR        R16
        RJMP       M_VERGL_0164
M_VERGL_0163:
        SER        R16
M_VERGL_0164:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0160
        RJMP       M_IF_0161
M_IF_0160:
 
; Retten der lokalen Parameter fuer PROCEDURE (TASTENNUMMER_ZU_TASTENZEICHEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_KEY)
        CALL       WRITE_KEY
 
; Retten der Parameter-Register fuer PROCEDURE (TASTENNUMMER_ZU_TASTENZEICHEN)
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0161:
 
; PROCEDURE - Ende (TASTENNUMMER_ZU_TASTENZEICHEN)
        RET
 
; PROCEDURE - Anfang (ANZEIGE_STATUS_LEDS)
ANZEIGE_STATUS_LEDS:
 
; IF THEN - Ausdruck / Byte-VAR (STATUS_LED_GELB)
        LDS        R16, STATUS_LED_GELB
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0165
        RJMP       M_IF_0166
M_IF_0165:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (WD_WORD)
        LDS        R16, WD_WORD
        LDS        R17, WD_WORD+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x8000)
        LDI        R18, LOW(0x8000)
        LDI        R19, HIGH(0x8000)
 
; Operator OR
        OR         R16, R18
        OR         R17, R19
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0167
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0166:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (WD_WORD)
        LDS        R16, WD_WORD
        LDS        R17, WD_WORD+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x7FFF)
        LDI        R18, LOW(0x7FFF)
        LDI        R19, HIGH(0x7FFF)
 
; Operator AND
        AND        R16, R18
        AND        R17, R19
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; IF_THEN_ELSE - Ende
M_IF_0167:
 
; IF THEN - Ausdruck / Byte-VAR (STATUS_LED_GRUEN)
        LDS        R16, STATUS_LED_GRUEN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0168
        RJMP       M_IF_0169
M_IF_0168:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (WD_WORD)
        LDS        R16, WD_WORD
        LDS        R17, WD_WORD+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0100)
        LDI        R18, LOW(0x0100)
        LDI        R19, HIGH(0x0100)
 
; Operator OR
        OR         R16, R18
        OR         R17, R19
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0170
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0169:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (WD_WORD)
        LDS        R16, WD_WORD
        LDS        R17, WD_WORD+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xFEFF)
        LDI        R18, LOW(0xFEFF)
        LDI        R19, HIGH(0xFEFF)
 
; Operator AND
        AND        R16, R18
        AND        R17, R19
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; IF_THEN_ELSE - Ende
M_IF_0170:
 
; IF THEN - Ausdruck / Byte-VAR (STATUS_LED_ROT_L)
        LDS        R16, STATUS_LED_ROT_L
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0171
        RJMP       M_IF_0172
M_IF_0171:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (WD_WORD)
        LDS        R16, WD_WORD
        LDS        R17, WD_WORD+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator OR
        OR         R16, R18
        OR         R17, R19
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0173
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0172:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (WD_WORD)
        LDS        R16, WD_WORD
        LDS        R17, WD_WORD+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xFF7F)
        LDI        R18, LOW(0xFF7F)
        LDI        R19, HIGH(0xFF7F)
 
; Operator AND
        AND        R16, R18
        AND        R17, R19
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; IF_THEN_ELSE - Ende
M_IF_0173:
 
; IF THEN - Ausdruck / Byte-VAR (STATUS_LED_ROT_R)
        LDS        R16, STATUS_LED_ROT_R
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0174
        RJMP       M_IF_0175
M_IF_0174:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (WD_WORD)
        LDS        R16, WD_WORD
        LDS        R17, WD_WORD+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator OR
        OR         R16, R18
        OR         R17, R19
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0176
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0175:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (WD_WORD)
        LDS        R16, WD_WORD
        LDS        R17, WD_WORD+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xFFFE)
        LDI        R18, LOW(0xFFFE)
        LDI        R19, HIGH(0xFFFE)
 
; Operator AND
        AND        R16, R18
        AND        R17, R19
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; IF_THEN_ELSE - Ende
M_IF_0176:
 
; Aufruf PROCEDURE (WRITE_DATA_WORD)
        CALL       WRITE_DATA_WORD
 
; PROCEDURE - Ende (ANZEIGE_STATUS_LEDS)
        RET
 
; PROCEDURE - Anfang (TASTATUR_LESEN)
TASTATUR_LESEN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x30)
        LDI        R16, 0x30
 
; Zuweisung Ziel /  VAR (TASTEN_NUMMER)
        STS        TASTEN_NUMMER, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0177:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0178
        RJMP       M_FTD_0179
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0178:
 
; CASE OF - lokale, dynamische Variable VAR (W2)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (00)
        CPI        R16, 0x00
        BREQ       M_CASE_0182
        RJMP       M_CASE_0181
M_CASE_0182:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x3E7E)
        LDI        R16, LOW(0x3E7E)
        LDI        R17, HIGH(0x3E7E)
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0180
M_CASE_0181:
 
; CASE OF - vergleiche Einzel-Element (01)
        CPI        R16, 0x01
        BREQ       M_CASE_0184
        RJMP       M_CASE_0183
M_CASE_0184:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x5E7E)
        LDI        R16, LOW(0x5E7E)
        LDI        R17, HIGH(0x5E7E)
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0180
M_CASE_0183:
 
; CASE OF - vergleiche Einzel-Element (02)
        CPI        R16, 0x02
        BREQ       M_CASE_0186
        RJMP       M_CASE_0185
M_CASE_0186:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x6E7E)
        LDI        R16, LOW(0x6E7E)
        LDI        R17, HIGH(0x6E7E)
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0180
M_CASE_0185:
 
; CASE OF - vergleiche Einzel-Element (03)
        CPI        R16, 0x03
        BREQ       M_CASE_0188
        RJMP       M_CASE_0187
M_CASE_0188:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x767E)
        LDI        R16, LOW(0x767E)
        LDI        R17, HIGH(0x767E)
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0180
M_CASE_0187:
 
; CASE OF - vergleiche Einzel-Element (04)
        CPI        R16, 0x04
        BREQ       M_CASE_0190
        RJMP       M_CASE_0189
M_CASE_0190:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x7A7E)
        LDI        R16, LOW(0x7A7E)
        LDI        R17, HIGH(0x7A7E)
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0180
M_CASE_0189:
 
; CASE OF - vergleiche Einzel-Element (05)
        CPI        R16, 0x05
        BREQ       M_CASE_0192
        RJMP       M_CASE_0191
M_CASE_0192:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x7C7E)
        LDI        R16, LOW(0x7C7E)
        LDI        R17, HIGH(0x7C7E)
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0180
M_CASE_0191:
 
; CASE OF - vergleiche Einzel-Element (06)
        CPI        R16, 0x06
        BREQ       M_CASE_0194
        RJMP       M_CASE_0193
M_CASE_0194:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x7E3E)
        LDI        R16, LOW(0x7E3E)
        LDI        R17, HIGH(0x7E3E)
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0180
M_CASE_0193:
 
; CASE OF - vergleiche Einzel-Element (07)
        CPI        R16, 0x07
        BREQ       M_CASE_0196
        RJMP       M_CASE_0195
M_CASE_0196:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x7E5E)
        LDI        R16, LOW(0x7E5E)
        LDI        R17, HIGH(0x7E5E)
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0180
M_CASE_0195:
 
; CASE OF - vergleiche Einzel-Element (08)
        CPI        R16, 0x08
        BREQ       M_CASE_0198
        RJMP       M_CASE_0197
M_CASE_0198:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x7E6E)
        LDI        R16, LOW(0x7E6E)
        LDI        R17, HIGH(0x7E6E)
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0180
M_CASE_0197:
 
; CASE OF - vergleiche Einzel-Element (09)
        CPI        R16, 0x09
        BREQ       M_CASE_0200
        RJMP       M_CASE_0199
M_CASE_0200:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x7E76)
        LDI        R16, LOW(0x7E76)
        LDI        R17, HIGH(0x7E76)
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0180
M_CASE_0199:
 
; CASE OF - vergleiche Einzel-Element (10)
        CPI        R16, 0x0A
        BREQ       M_CASE_0202
        RJMP       M_CASE_0201
M_CASE_0202:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x7E7A)
        LDI        R16, LOW(0x7E7A)
        LDI        R17, HIGH(0x7E7A)
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0180
M_CASE_0201:
 
; CASE OF - vergleiche Einzel-Element (11)
        CPI        R16, 0x0B
        BREQ       M_CASE_0204
        RJMP       M_CASE_0203
M_CASE_0204:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x7E7C)
        LDI        R16, LOW(0x7E7C)
        LDI        R17, HIGH(0x7E7C)
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; ENDCASE;
M_CASE_0203:
M_CASE_0180:
 
; Retten der lokalen Parameter fuer PROCEDURE (TASTATUR_LESEN)
        PUSH       R0
 
; Aufruf PROCEDURE (ANZEIGE_STATUS_LEDS)
        CALL       ANZEIGE_STATUS_LEDS
 
; Retten der Parameter-Register fuer PROCEDURE (TASTATUR_LESEN)
        POP        R0
 
; IF THEN - Ausdruck /; BitLow(TZ_00)
        IN         R16, PIND
        BST        R16, 1
        BRTC       M_VERGL_0208
        CLR        R16
        RJMP       M_VERGL_0209
M_VERGL_0208:
        SER        R16
M_VERGL_0209:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0205
        RJMP       M_IF_0206
M_IF_0205:
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (W2)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (TASTEN_NUMMER)
        STS        TASTEN_NUMMER, R16
 
; IF_THEN - Ende
M_IF_0206:
 
; IF THEN - Ausdruck /; BitLow(TZ_01)
        IN         R16, PIND
        BST        R16, 0
        BRTC       M_VERGL_0213
        CLR        R16
        RJMP       M_VERGL_0214
M_VERGL_0213:
        SER        R16
M_VERGL_0214:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0210
        RJMP       M_IF_0211
M_IF_0210:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W2)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0C)
        LDI        R18, 0x0C
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  VAR (TASTEN_NUMMER)
        STS        TASTEN_NUMMER, R16
 
; IF_THEN - Ende
M_IF_0211:
 
; IF THEN - Ausdruck /; BitLow(TZ_02)
        IN         R16, PIND
        BST        R16, 2
        BRTC       M_VERGL_0218
        CLR        R16
        RJMP       M_VERGL_0219
M_VERGL_0218:
        SER        R16
M_VERGL_0219:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0215
        RJMP       M_IF_0216
M_IF_0215:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W2)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x18)
        LDI        R18, 0x18
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  VAR (TASTEN_NUMMER)
        STS        TASTEN_NUMMER, R16
 
; IF_THEN - Ende
M_IF_0216:
 
; IF THEN - Ausdruck /; BitLow(TZ_03)
        IN         R16, PIND
        BST        R16, 3
        BRTC       M_VERGL_0223
        CLR        R16
        RJMP       M_VERGL_0224
M_VERGL_0223:
        SER        R16
M_VERGL_0224:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0220
        RJMP       M_IF_0221
M_IF_0220:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W2)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x24)
        LDI        R18, 0x24
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  VAR (TASTEN_NUMMER)
        STS        TASTEN_NUMMER, R16
 
; IF_THEN - Ende
M_IF_0221:
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0177
 
; FOR TO DO - Ende
M_FTD_0179:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (TASTEN_NUMMER)
        LDS        R16, TASTEN_NUMMER
 
; IF THEN - Ausdruck zweiter Faktor / Byte-VAR (LETZTE_TASTEN_NUMMER)
        LDS        R18, LETZTE_TASTEN_NUMMER
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0228
        CLR        R16
        RJMP       M_VERGL_0229
M_VERGL_0228:
        SER        R16
M_VERGL_0229:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0225
        RJMP       M_IF_0226
M_IF_0225:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ENTPRELL_ZAEHLER)
        LDS        R16, ENTPRELL_ZAEHLER
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0233
        CLR        R16
        RJMP       M_VERGL_0234
M_VERGL_0233:
        SER        R16
M_VERGL_0234:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0230
        RJMP       M_IF_0231
M_IF_0230:
 
; DEC(ENTPRELL_ZAEHLER) - Byte
        LDS        R16, ENTPRELL_ZAEHLER
        DEC        R16
        STS        ENTPRELL_ZAEHLER, R16
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ENTPRELL_ZAEHLER)
        LDS        R16, ENTPRELL_ZAEHLER
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0238
        CLR        R16
        RJMP       M_VERGL_0239
M_VERGL_0238:
        SER        R16
M_VERGL_0239:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0235
        RJMP       M_IF_0236
M_IF_0235:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (TASTEN_NUMMER)
        LDS        R16, TASTEN_NUMMER
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator <
        CP         R16, R18
        BRCS       M_VERGL_0243
        CLR        R16
        RJMP       M_VERGL_0244
M_VERGL_0243:
        SER        R16
M_VERGL_0244:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0240
        RJMP       M_IF_0241
M_IF_0240:
 
; Retten der lokalen Parameter fuer PROCEDURE (TASTATUR_LESEN)
        PUSH       R0
 
; Aufruf PROCEDURE (TASTENNUMMER_ZU_TASTENZEICHEN)
        CALL       TASTENNUMMER_ZU_TASTENZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (TASTATUR_LESEN)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (TASTATUR_LESEN)
        PUSH       R0
 
; Aufruf PROCEDURE (CLICK)
        CALL       CLICK
 
; Retten der Parameter-Register fuer PROCEDURE (TASTATUR_LESEN)
        POP        R0
 
; IF_THEN - Ende
M_IF_0241:
 
; IF_THEN - Ende
M_IF_0236:
 
; IF_THEN - Ende
M_IF_0231:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0227
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0226:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (TASTEN_NUMMER)
        LDS        R16, TASTEN_NUMMER
 
; Zuweisung Ziel /  VAR (LETZTE_TASTEN_NUMMER)
        STS        LETZTE_TASTEN_NUMMER, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0A)
        LDI        R16, 0x0A
 
; Zuweisung Ziel /  VAR (ENTPRELL_ZAEHLER)
        STS        ENTPRELL_ZAEHLER, R16
 
; IF_THEN_ELSE - Ende
M_IF_0227:
 
; PROCEDURE - Ende (TASTATUR_LESEN)
        RET
 
; PROCEDURE - Anfang (ITP3_CLIENT_INIT)
ITP3_CLIENT_INIT:
 
; ClearBit(D0_D)
        CBI        DDRC, 0
 
; ClearBit(D1_D)
        CBI        DDRC, 1
 
; ClearBit(D2_D)
        CBI        DDRC, 2
 
; ClearBit(D3_D)
        CBI        DDRC, 3
 
; ClearBit(DS_D)
        CBI        DDRC, 4
 
; ClearBit(DR_D)
        CBI        DDRC, 5
 
; PROCEDURE - Ende (ITP3_CLIENT_INIT)
        RET
 
; FUNCTION - Anfang (ITP3_HALBBYTE_EINLESEN)
ITP3_HALBBYTE_EINLESEN:
 
; SetBit(LED_BL_L)
        SBI        PORTD, 4
 
; WHILE DO ...
M_WHILE_0245:
 
; WHILE - Ausdruck /; BitHigh(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTS       M_VERGL_0248
        CLR        R16
        RJMP       M_VERGL_0249
M_VERGL_0248:
        SER        R16
M_VERGL_0249:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0246
        RJMP       M_WHILE_0247
M_WHILE_0246:
 
; WHILE DO ...
        RJMP       M_WHILE_0245
M_WHILE_0247:
 
; ClearBit(LED_BL_L)
        CBI        PORTD, 4
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck /; BitHigh(D0_E)
        IN         R16, PINC
        BST        R16, 0
        BRTS       M_VERGL_0253
        CLR        R16
        RJMP       M_VERGL_0254
M_VERGL_0253:
        SER        R16
M_VERGL_0254:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0250
        RJMP       M_IF_0251
M_IF_0250:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0251:
 
; IF THEN - Ausdruck /; BitHigh(D1_E)
        IN         R16, PINC
        BST        R16, 1
        BRTS       M_VERGL_0258
        CLR        R16
        RJMP       M_VERGL_0259
M_VERGL_0258:
        SER        R16
M_VERGL_0259:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0255
        RJMP       M_IF_0256
M_IF_0255:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0256:
 
; IF THEN - Ausdruck /; BitHigh(D2_E)
        IN         R16, PINC
        BST        R16, 2
        BRTS       M_VERGL_0263
        CLR        R16
        RJMP       M_VERGL_0264
M_VERGL_0263:
        SER        R16
M_VERGL_0264:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0260
        RJMP       M_IF_0261
M_IF_0260:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0261:
 
; IF THEN - Ausdruck /; BitHigh(D3_E)
        IN         R16, PINC
        BST        R16, 3
        BRTS       M_VERGL_0268
        CLR        R16
        RJMP       M_VERGL_0269
M_VERGL_0268:
        SER        R16
M_VERGL_0269:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0265
        RJMP       M_IF_0266
M_IF_0265:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0266:
 
; ClearBit(DR_A)
        CBI        PORTC, 5
 
; SetBit(LED_BL_L)
        SBI        PORTD, 4
 
; WHILE DO ...
M_WHILE_0270:
 
; WHILE - Ausdruck /; BitLow(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTC       M_VERGL_0273
        CLR        R16
        RJMP       M_VERGL_0274
M_VERGL_0273:
        SER        R16
M_VERGL_0274:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0271
        RJMP       M_WHILE_0272
M_WHILE_0271:
 
; WHILE DO ...
        RJMP       M_WHILE_0270
M_WHILE_0272:
 
; ClearBit(LED_BL_L)
        CBI        PORTD, 4
 
; SetBit(DR_A)
        SBI        PORTC, 5
 
; RESULT Byte-Variable - FUNCTION (ITP3_HALBBYTE_EINLESEN)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (ITP3_HALBBYTE_EINLESEN)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_HALBBYTE_EINLESEN)
        RET
 
; FUNCTION - Anfang (ITP3_BYTE_EINLESEN)
ITP3_BYTE_EINLESEN:
 
; SetBit(DR_A)
        SBI        PORTC, 5
 
; SetBit(DR_D)
        SBI        DDRC, 5
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_BYTE_EINLESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (ITP3_HALBBYTE_EINLESEN)
        CALL       ITP3_HALBBYTE_EINLESEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_BYTE_EINLESEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_BYTE_EINLESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (ITP3_HALBBYTE_EINLESEN)
        CALL       ITP3_HALBBYTE_EINLESEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_BYTE_EINLESEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; ClearBit(DR_D)
        CBI        DDRC, 5
 
; SHL(B1) - Byte
        LSL        R1
 
; SHL(B1) - Byte
        LSL        R1
 
; SHL(B1) - Byte
        LSL        R1
 
; SHL(B1) - Byte
        LSL        R1
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R2, R16
 
; RESULT Byte-Variable - FUNCTION (ITP3_BYTE_EINLESEN)
        MOV        R0, R2
 
; Ende Byte - FUNCTION (ITP3_BYTE_EINLESEN)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_BYTE_EINLESEN)
        RET
 
; PROCEDURE - Anfang (ITP3_HALBBYTE_AUSGEBEN)
ITP3_HALBBYTE_AUSGEBEN:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0278
        CLR        R16
        RJMP       M_VERGL_0279
M_VERGL_0278:
        SER        R16
M_VERGL_0279:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0275
        RJMP       M_IF_0276
M_IF_0275:
 
; ClearBit(D0_A)
        CBI        PORTC, 0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0277
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0276:
 
; SetBit(D0_A)
        SBI        PORTC, 0
 
; IF_THEN_ELSE - Ende
M_IF_0277:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0283
        CLR        R16
        RJMP       M_VERGL_0284
M_VERGL_0283:
        SER        R16
M_VERGL_0284:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0280
        RJMP       M_IF_0281
M_IF_0280:
 
; ClearBit(D1_A)
        CBI        PORTC, 1
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0282
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0281:
 
; SetBit(D1_A)
        SBI        PORTC, 1
 
; IF_THEN_ELSE - Ende
M_IF_0282:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0288
        CLR        R16
        RJMP       M_VERGL_0289
M_VERGL_0288:
        SER        R16
M_VERGL_0289:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0285
        RJMP       M_IF_0286
M_IF_0285:
 
; ClearBit(D2_A)
        CBI        PORTC, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0287
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0286:
 
; SetBit(D2_A)
        SBI        PORTC, 2
 
; IF_THEN_ELSE - Ende
M_IF_0287:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0293
        CLR        R16
        RJMP       M_VERGL_0294
M_VERGL_0293:
        SER        R16
M_VERGL_0294:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0290
        RJMP       M_IF_0291
M_IF_0290:
 
; ClearBit(D3_A)
        CBI        PORTC, 3
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0292
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0291:
 
; SetBit(D3_A)
        SBI        PORTC, 3
 
; IF_THEN_ELSE - Ende
M_IF_0292:
 
; ClearBit(DR_A)
        CBI        PORTC, 5
 
; SetBit(LED_BL_L)
        SBI        PORTD, 4
 
; WHILE DO ...
M_WHILE_0295:
 
; WHILE - Ausdruck /; BitLow(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTC       M_VERGL_0298
        CLR        R16
        RJMP       M_VERGL_0299
M_VERGL_0298:
        SER        R16
M_VERGL_0299:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0296
        RJMP       M_WHILE_0297
M_WHILE_0296:
 
; WHILE DO ...
        RJMP       M_WHILE_0295
M_WHILE_0297:
 
; ClearBit(LED_BL_L)
        CBI        PORTD, 4
 
; SetBit(DR_A)
        SBI        PORTC, 5
 
; PROCEDURE - Ende (ITP3_HALBBYTE_AUSGEBEN)
        RET
 
; PROCEDURE - Anfang (ITP3_BYTE_AUSGEBEN)
ITP3_BYTE_AUSGEBEN:
 
; SetBit(DR_A)
        SBI        PORTC, 5
 
; SetBit(DR_D)
        SBI        DDRC, 5
 
; SetBit(LED_BL_L)
        SBI        PORTD, 4
 
; WHILE DO ...
M_WHILE_0300:
 
; WHILE - Ausdruck /; BitHigh(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTS       M_VERGL_0303
        CLR        R16
        RJMP       M_VERGL_0304
M_VERGL_0303:
        SER        R16
M_VERGL_0304:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0301
        RJMP       M_WHILE_0302
M_WHILE_0301:
 
; WHILE DO ...
        RJMP       M_WHILE_0300
M_WHILE_0302:
 
; ClearBit(LED_BL_L)
        CBI        PORTD, 4
 
; SetBit(D0_D)
        SBI        DDRC, 0
 
; SetBit(D1_D)
        SBI        DDRC, 1
 
; SetBit(D2_D)
        SBI        DDRC, 2
 
; SetBit(D3_D)
        SBI        DDRC, 3
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_BYTE_AUSGEBEN)
        PUSH       R0
        PUSH       R1
 
; Parameter (B1) retten
        MOV        R17, R1
 
; lokalen Parameter (B1) an Prozedur (ITP3_HALBBYTE_AUSGEBEN)
        MOV        R0, R17
 
; Aufruf PROCEDURE (ITP3_HALBBYTE_AUSGEBEN)
        CALL       ITP3_HALBBYTE_AUSGEBEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_BYTE_AUSGEBEN)
        POP        R1
        POP        R0
 
; SHR(H_BYTE) - Byte
        LSR        R0
 
; SHR(H_BYTE) - Byte
        LSR        R0
 
; SHR(H_BYTE) - Byte
        LSR        R0
 
; SHR(H_BYTE) - Byte
        LSR        R0
 
; SetBit(LED_BL_L)
        SBI        PORTD, 4
 
; WHILE DO ...
M_WHILE_0305:
 
; WHILE - Ausdruck /; BitHigh(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTS       M_VERGL_0308
        CLR        R16
        RJMP       M_VERGL_0309
M_VERGL_0308:
        SER        R16
M_VERGL_0309:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0306
        RJMP       M_WHILE_0307
M_WHILE_0306:
 
; WHILE DO ...
        RJMP       M_WHILE_0305
M_WHILE_0307:
 
; ClearBit(LED_BL_L)
        CBI        PORTD, 4
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_BYTE_AUSGEBEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ITP3_HALBBYTE_AUSGEBEN)
        CALL       ITP3_HALBBYTE_AUSGEBEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_BYTE_AUSGEBEN)
        POP        R1
        POP        R0
 
; ClearBit(DR_D)
        CBI        DDRC, 5
 
; ClearBit(D0_D)
        CBI        DDRC, 0
 
; ClearBit(D1_D)
        CBI        DDRC, 1
 
; ClearBit(D2_D)
        CBI        DDRC, 2
 
; ClearBit(D3_D)
        CBI        DDRC, 3
 
; PROCEDURE - Ende (ITP3_BYTE_AUSGEBEN)
        RET
 
; PROCEDURE - Anfang (ITP3_PRG_CONOUT)
ITP3_PRG_CONOUT:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRG_CONOUT)
        PUSH       R0
 
; Aufruf Funktion (ITP3_BYTE_EINLESEN)
        CALL       ITP3_BYTE_EINLESEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRG_CONOUT)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (STATUS_LED_ROT_R)
        STS        STATUS_LED_ROT_R, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRG_CONOUT)
        PUSH       R0
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x000A)
        MOV        R0, R16
        LDI        R17, HIGH(0x000A)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRG_CONOUT)
        POP        R0
 
; PROCEDURE - Ende (ITP3_PRG_CONOUT)
        RET
 
; PROCEDURE - Anfang (ITP3_PRG_WHO_AM_I)
ITP3_PRG_WHO_AM_I:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x40)
        LDI        R16, 0x40
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRG_WHO_AM_I)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_BYTE_AUSGEBEN)
        CALL       ITP3_BYTE_AUSGEBEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRG_WHO_AM_I)
        POP        R0
 
; PROCEDURE - Ende (ITP3_PRG_WHO_AM_I)
        RET
 
; PROCEDURE - Anfang (ITP3_PRG_CONST)
ITP3_PRG_CONST:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0313
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0314
M_VERGL_0313:
        SER        R16
M_VERGL_0314:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0310
        RJMP       M_IF_0311
M_IF_0310:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R0, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0312
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0311:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R0, R16
 
; IF_THEN_ELSE - Ende
M_IF_0312:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRG_CONST)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_BYTE_AUSGEBEN)
        CALL       ITP3_BYTE_AUSGEBEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRG_CONST)
        POP        R0
 
; PROCEDURE - Ende (ITP3_PRG_CONST)
        RET
 
; PROCEDURE - Anfang (ITP3_PRG_CONIN)
ITP3_PRG_CONIN:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRG_CONIN)
        PUSH       R0
 
; Aufruf Funktion (READ_KEY)
        CALL       READ_KEY
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRG_CONIN)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRG_CONIN)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_BYTE_AUSGEBEN)
        CALL       ITP3_BYTE_AUSGEBEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRG_CONIN)
        POP        R0
 
; PROCEDURE - Ende (ITP3_PRG_CONIN)
        RET
 
; PROCEDURE - Anfang (ITP3_SERVER_ABFRAGE)
ITP3_SERVER_ABFRAGE:
 
; IF THEN - Ausdruck /; BitLow(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTC       M_VERGL_0318
        CLR        R16
        RJMP       M_VERGL_0319
M_VERGL_0318:
        SER        R16
M_VERGL_0319:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0315
        RJMP       M_IF_0316
M_IF_0315:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        PUSH       R0
 
; Aufruf Funktion (ITP3_BYTE_EINLESEN)
        CALL       ITP3_BYTE_EINLESEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (CODE_BYTE)
        MOV        R0, R16
 
; CASE OF - lokale, dynamische Variable VAR (CODE_BYTE)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (ITP3_WHO_AM_I)
        CPI        R16, 0x01
        BREQ       M_CASE_0322
        RJMP       M_CASE_0321
M_CASE_0322:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_PRG_WHO_AM_I)
        CALL       ITP3_PRG_WHO_AM_I
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0320
M_CASE_0321:
 
; CASE OF - vergleiche Einzel-Element (ITP3_CONOUT)
        CPI        R16, 0x03
        BREQ       M_CASE_0324
        RJMP       M_CASE_0323
M_CASE_0324:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_PRG_CONOUT)
        CALL       ITP3_PRG_CONOUT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0320
M_CASE_0323:
 
; CASE OF - vergleiche Einzel-Element (ITP3_CONST)
        CPI        R16, 0x04
        BREQ       M_CASE_0326
        RJMP       M_CASE_0325
M_CASE_0326:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_PRG_CONST)
        CALL       ITP3_PRG_CONST
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0320
M_CASE_0325:
 
; CASE OF - vergleiche Einzel-Element (ITP3_CONIN)
        CPI        R16, 0x05
        BREQ       M_CASE_0328
        RJMP       M_CASE_0327
M_CASE_0328:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_PRG_CONIN)
        CALL       ITP3_PRG_CONIN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        POP        R0
 
; ENDCASE;
M_CASE_0327:
M_CASE_0320:
 
; IF_THEN - Ende
M_IF_0316:
 
; PROCEDURE - Ende (ITP3_SERVER_ABFRAGE)
        RET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xF0)
        LDI        R16, 0xF0
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTD)
        OUT        PORTD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; PROCEDURE - Anfang (WAIT_MS2)
WAIT_MS2:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (ZEIT)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0329:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0330
        RJMP       M_FTD_0331
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0330:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x000A)
        LDI        R16, LOW(0x000A)
        LDI        R17, HIGH(0x000A)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0332:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0333
        RJMP       M_FTD_0334
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0333:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0332
 
; FOR TO DO - Ende
M_FTD_0334:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0329
 
; FOR TO DO - Ende
M_FTD_0331:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (WAIT_MS2)
        RET
 
; PROCEDURE - Anfang (TON)
TON:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W0)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (DAUER)
        MOV        R16, R2
        MOV        R17, R3
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0335:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0336
        RJMP       M_FTD_0337
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0336:
 
; ClearBit(LSP_D0)
        CBI        PORTB, 0
 
; ClearBit(LSP_D1)
        CBI        PORTB, 1
 
; Retten der lokalen Parameter fuer PROCEDURE (TON)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WAIT_MS2)
        CALL       WAIT_MS2
 
; Retten der Parameter-Register fuer PROCEDURE (TON)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; SetBit(LSP_D0)
        SBI        PORTB, 0
 
; ClearBit(LSP_D1)
        CBI        PORTB, 1
 
; Retten der lokalen Parameter fuer PROCEDURE (TON)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WAIT_MS2)
        CALL       WAIT_MS2
 
; Retten der Parameter-Register fuer PROCEDURE (TON)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ClearBit(LSP_D0)
        CBI        PORTB, 0
 
; SetBit(LSP_D1)
        SBI        PORTB, 1
 
; Retten der lokalen Parameter fuer PROCEDURE (TON)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WAIT_MS2)
        CALL       WAIT_MS2
 
; Retten der Parameter-Register fuer PROCEDURE (TON)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; SetBit(LSP_D0)
        SBI        PORTB, 0
 
; SetBit(LSP_D1)
        SBI        PORTB, 1
 
; Retten der lokalen Parameter fuer PROCEDURE (TON)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WAIT_MS2)
        CALL       WAIT_MS2
 
; Retten der Parameter-Register fuer PROCEDURE (TON)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ClearBit(LSP_D0)
        CBI        PORTB, 0
 
; SetBit(LSP_D1)
        SBI        PORTB, 1
 
; Retten der lokalen Parameter fuer PROCEDURE (TON)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WAIT_MS2)
        CALL       WAIT_MS2
 
; Retten der Parameter-Register fuer PROCEDURE (TON)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; SetBit(LSP_D0)
        SBI        PORTB, 0
 
; ClearBit(LSP_D1)
        CBI        PORTB, 1
 
; Retten der lokalen Parameter fuer PROCEDURE (TON)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WAIT_MS2)
        CALL       WAIT_MS2
 
; Retten der Parameter-Register fuer PROCEDURE (TON)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0335
 
; FOR TO DO - Ende
M_FTD_0337:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (TON)
        RET
 
; PROCEDURE - Anfang (TON2)
TON2:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; Aufruf PROCEDURE (WRITE_DATA_WORD)
        CALL       WRITE_DATA_WORD
 
; Word-Parameter(1) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x000A)
        MOV        R0, R16
        LDI        R17, HIGH(0x000A)
        MOV        R1, R17
 
; Word-Parameter(2) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x0014)
        MOV        R2, R16
        LDI        R17, HIGH(0x0014)
        MOV        R3, R17
 
; Aufruf PROCEDURE (TON)
        CALL       TON
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0014)
        MOV        R0, R16
        LDI        R17, HIGH(0x0014)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Word-Parameter(1) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x0050)
        MOV        R0, R16
        LDI        R17, HIGH(0x0050)
        MOV        R1, R17
 
; Word-Parameter(2) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x0014)
        MOV        R2, R16
        LDI        R17, HIGH(0x0014)
        MOV        R3, R17
 
; Aufruf PROCEDURE (TON)
        CALL       TON
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0014)
        MOV        R0, R16
        LDI        R17, HIGH(0x0014)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Word-Parameter(1) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x003C)
        MOV        R0, R16
        LDI        R17, HIGH(0x003C)
        MOV        R1, R17
 
; Word-Parameter(2) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x0014)
        MOV        R2, R16
        LDI        R17, HIGH(0x0014)
        MOV        R3, R17
 
; Aufruf PROCEDURE (TON)
        CALL       TON
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0014)
        MOV        R0, R16
        LDI        R17, HIGH(0x0014)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Word-Parameter(1) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x001E)
        MOV        R0, R16
        LDI        R17, HIGH(0x001E)
        MOV        R1, R17
 
; Word-Parameter(2) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x0014)
        MOV        R2, R16
        LDI        R17, HIGH(0x0014)
        MOV        R3, R17
 
; Aufruf PROCEDURE (TON)
        CALL       TON
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0014)
        MOV        R0, R16
        LDI        R17, HIGH(0x0014)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFFFF)
        LDI        R16, LOW(0xFFFF)
        LDI        R17, HIGH(0xFFFF)
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; Aufruf PROCEDURE (WRITE_DATA_WORD)
        CALL       WRITE_DATA_WORD
 
; Word-Parameter(1) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x0014)
        MOV        R0, R16
        LDI        R17, HIGH(0x0014)
        MOV        R1, R17
 
; Word-Parameter(2) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x000A)
        MOV        R2, R16
        LDI        R17, HIGH(0x000A)
        MOV        R3, R17
 
; Aufruf PROCEDURE (TON)
        CALL       TON
 
; Word-Parameter(1) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x0019)
        MOV        R0, R16
        LDI        R17, HIGH(0x0019)
        MOV        R1, R17
 
; Word-Parameter(2) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x000A)
        MOV        R2, R16
        LDI        R17, HIGH(0x000A)
        MOV        R3, R17
 
; Aufruf PROCEDURE (TON)
        CALL       TON
 
; Word-Parameter(1) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x0016)
        MOV        R0, R16
        LDI        R17, HIGH(0x0016)
        MOV        R1, R17
 
; Word-Parameter(2) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x000A)
        MOV        R2, R16
        LDI        R17, HIGH(0x000A)
        MOV        R3, R17
 
; Aufruf PROCEDURE (TON)
        CALL       TON
 
; Word-Parameter(1) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x0012)
        MOV        R0, R16
        LDI        R17, HIGH(0x0012)
        MOV        R1, R17
 
; Word-Parameter(2) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x000A)
        MOV        R2, R16
        LDI        R17, HIGH(0x000A)
        MOV        R3, R17
 
; Aufruf PROCEDURE (TON)
        CALL       TON
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; Aufruf PROCEDURE (WRITE_DATA_WORD)
        CALL       WRITE_DATA_WORD
 
; PROCEDURE - Ende (TON2)
        RET
 
; PROCEDURE - Anfang (TON3)
TON3:
 
; SetBit(LED_BL_L)
        SBI        PORTD, 4
 
; SetBit(LED_BL_R)
        SBI        PORTD, 5
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFFFF)
        LDI        R16, LOW(0xFFFF)
        LDI        R17, HIGH(0xFFFF)
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; Aufruf PROCEDURE (WRITE_DATA_WORD)
        CALL       WRITE_DATA_WORD
 
; Word-Parameter(1) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x0014)
        MOV        R0, R16
        LDI        R17, HIGH(0x0014)
        MOV        R1, R17
 
; Word-Parameter(2) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x0005)
        MOV        R2, R16
        LDI        R17, HIGH(0x0005)
        MOV        R3, R17
 
; Aufruf PROCEDURE (TON)
        CALL       TON
 
; Word-Parameter(1) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x0019)
        MOV        R0, R16
        LDI        R17, HIGH(0x0019)
        MOV        R1, R17
 
; Word-Parameter(2) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x0005)
        MOV        R2, R16
        LDI        R17, HIGH(0x0005)
        MOV        R3, R17
 
; Aufruf PROCEDURE (TON)
        CALL       TON
 
; Word-Parameter(1) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x0016)
        MOV        R0, R16
        LDI        R17, HIGH(0x0016)
        MOV        R1, R17
 
; Word-Parameter(2) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x0005)
        MOV        R2, R16
        LDI        R17, HIGH(0x0005)
        MOV        R3, R17
 
; Aufruf PROCEDURE (TON)
        CALL       TON
 
; Word-Parameter(1) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x0012)
        MOV        R0, R16
        LDI        R17, HIGH(0x0012)
        MOV        R1, R17
 
; Word-Parameter(2) fuer PROCEDURE (TON)
        LDI        R16, LOW(0x0005)
        MOV        R2, R16
        LDI        R17, HIGH(0x0005)
        MOV        R3, R17
 
; Aufruf PROCEDURE (TON)
        CALL       TON
 
; ClearBit(LED_BL_L)
        CBI        PORTD, 4
 
; ClearBit(LED_BL_R)
        CBI        PORTD, 5
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (WD_WORD)
        STS        WD_WORD, R16
        STS        WD_WORD+1, R17
 
; Aufruf PROCEDURE (WRITE_DATA_WORD)
        CALL       WRITE_DATA_WORD
 
; PROCEDURE - Ende (TON3)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
 
; Aufruf PROCEDURE (INITPORTS)
        CALL       INITPORTS
 
; Aufruf PROCEDURE (KBD_INIT)
        CALL       KBD_INIT
 
; Aufruf PROCEDURE (ITP3_CLIENT_INIT)
        CALL       ITP3_CLIENT_INIT
 
; Aufruf PROCEDURE (TON3)
        CALL       TON3
 
; ClearBit(LED_BL_R)
        CBI        PORTD, 5
 
; LOOP - Start_Marke
M_LOOP_0338:
 
; Aufruf PROCEDURE (TASTATUR_LESEN)
        CALL       TASTATUR_LESEN
 
; Aufruf PROCEDURE (ITP3_SERVER_ABFRAGE)
        CALL       ITP3_SERVER_ABFRAGE
 
; LOOP - Ende
        RJMP       M_LOOP_0338
 
; *** Unterprogramm Bibliothek ***
; Multiplikation von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17 erster Faktor
;            R18:R19 zweiter Faktor
; Temporaere Register: R20,R21,R22,R23,R24 
;                      R2 ,R3  R4  R5  R6
ASM_UP_MUL16:
 
        PUSH       R0
        PUSH       R1

        CLR        R24
        MUL        R19, R17
        MOVW       R23:R22, R1:R0
        MUL        R18, R16
        MOVW       R21:R20, R1:R0
        MUL        R19, R16
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MUL        R17, R18
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MOVW       R17:R16, R21:R20       ; Produkt Low
        MOVW       R19:R18, R23:R22       ; Produkt High

        POP        R1
        POP        R0		

        RET






 
; *** Namen-Liste ***
;
; UDR0 (V) BYTECONVAR
; UBRR0H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; TWAMR (V) BYTECONVAR
; TWCR (V) BYTECONVAR
; TWDR (V) BYTECONVAR
; TWAR (V) BYTECONVAR
; TWSR (V) BYTECONVAR
; TWBR (V) BYTECONVAR
; ASSR (V) BYTECONVAR
; OCR2B (V) BYTECONVAR
; OCR2A (V) BYTECONVAR
; TCNT2 (V) BYTECONVAR
; TCCR2B (V) BYTECONVAR
; TCCR2A (V) BYTECONVAR
; TIMSK2 (V) BYTECONVAR
; TIMSK1 (V) BYTECONVAR
; TIMSK0 (V) BYTECONVAR
; OCR1BL (V) BYTECONVAR
; OCR1BH (V) BYTECONVAR
; OCR1AH (V) BYTECONVAR
; OCR1AL (V) BYTECONVAR
; ICR1L (V) BYTECONVAR
; ICR1H (V) BYTECONVAR
; TCNT1L (V) BYTECONVAR
; TCNT1H (V) BYTECONVAR
; TCCR1C (V) BYTECONVAR
; TCCR1B (V) BYTECONVAR
; TCCR1A (V) BYTECONVAR
; DIDR1 (V) BYTECONVAR
; DIDR0 (V) BYTECONVAR
; ADMUX (V) BYTECONVAR
; ADCSRB (V) BYTECONVAR
; ADCSRA (V) BYTECONVAR
; ADCH (V) BYTECONVAR
; ADCL (V) BYTECONVAR
; PCMSK0 (V) BYTECONVAR
; PCMSK1 (V) BYTECONVAR
; PCMSK2 (V) BYTECONVAR
; PCMSK3 (V) BYTECONVAR
; EICRA (V) BYTECONVAR
; PCICR (V) BYTECONVAR
; OSCCAL (V) BYTECONVAR
; PRR0 (V) BYTECONVAR
; CLKPR (V) BYTECONVAR
; WDTCSR (V) BYTECONVAR
; SREG (V) BYTECONREG
; SPL (V) BYTECONREG
; SPH (V) BYTECONREG
; SPMCSR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; SMCR (V) BYTECONREG
; OCDR (V) BYTECONREG
; ACSR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; GPIOR0 (V) BYTECONREG
; GPIOR1 (V) BYTECONREG
; GPIOR2 (V) BYTECONREG
; OCR0A (V) BYTECONREG
; OCR0B (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; TCCR0A (V) BYTECONREG
; TCCR0B (V) BYTECONREG
; GTCCR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; EIMSK (V) BYTECONREG
; EIFR (V) BYTECONREG
; PCIFR (V) BYTECONREG
; TIFR2 (V) BYTECONREG
; TIFR1 (V) BYTECONREG
; TIFR0 (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; RXC0 (B) BIT
; TXC0 (B) BIT
; UDRE0 (B) BIT
; TAKTFREQUENZ (C) WORD Wert=0x1F40
; LSP_D0 (B) BIT
; LSP_D1 (B) BIT
; SERIAL_DATA (B) BIT
; TZ_00 (B) BIT
; TZ_01 (B) BIT
; TZ_02 (B) BIT
; TZ_03 (B) BIT
; LED_BL_L (B) BIT
; LED_BL_R (B) BIT
; SHIFT_CLOCK (B) BIT
; LATCH_CLOCK (B) BIT
; STATUS_LED_GELB (V) BOOLEAN
; STATUS_LED_GRUEN (V) BOOLEAN
; STATUS_LED_ROT_L (V) BOOLEAN
; STATUS_LED_ROT_R (V) BOOLEAN
; WAITKON (C) WORD Wert=0x0008
; WAITKON2 (C) WORD Wert=0x0168
; BYTE_STRING (V) STRING
; WORD_STRING (V) STRING
; DWORD_STRING (V) STRING
; BYTEPOSTOORMASKE (F) 
; BYTEPOSTOANDMASKE (F) 
; READ_BIT_IN_BYTE (F) 
; SET_BIT_IN_BYTE (F) 
; CLEAR_BIT_IN_BYTE (F) 
; NEGATION_BYTE (F) 
; WAIT_MS (P) 
; BYTETOSTRING (P) 
; STRINGTOBYTE (F) 
; WORDTOSTRING (P) 
; STRINGTOWORD (F) 
; DWORDTOSTRING (P) 
; TON_SIRENE (P) 
; CLICK (P) 
; TASTENTABELLE_NORMAL (A) 
; TASTENTABELLE_SHIFT (A) 
; TASTENTABELLE_CTRL (A) 
; WD_WORD (V) WORD
; KEYBUFFER (Y) BYTE
; KEYBUFFERPTR (V) WORD
; TASTEN_NUMMER (V) BYTE
; LETZTE_TASTEN_NUMMER (V) BYTE
; ENTPRELL_ZAEHLER (V) BYTE
; TEXT_STRING (V) STRING
; SHIFT_IST_AKTIV (V) BOOLEAN
; CTRL_IST_AKTIV (V) BOOLEAN
; KBD_INIT (P) 
; READ_KEY (F) 
; WRITE_KEY (P) 
; WRITE_C_KEY (P) 
; WRITE_TEXT (P) 
; WRITE_DATA_WORD (P) 
; TASTENNUMMER_ZU_TASTENZEICHEN (P) 
; ANZEIGE_STATUS_LEDS (P) 
; TASTATUR_LESEN (P) 
; D0_A (B) BIT
; D1_A (B) BIT
; D2_A (B) BIT
; D3_A (B) BIT
; DR_A (B) BIT
; D0_D (B) BIT
; D1_D (B) BIT
; D2_D (B) BIT
; D3_D (B) BIT
; DR_D (B) BIT
; D0_E (B) BIT
; D1_E (B) BIT
; D2_E (B) BIT
; D3_E (B) BIT
; DR_E (B) BIT
; DS_A (B) BIT
; DS_D (B) BIT
; DS_E (B) BIT
; ITP3_WHO_AM_I (C) BYTE Wert=0x01
; ITP3_ERROR_CODE (C) BYTE Wert=0x02
; ITP3_CONOUT (C) BYTE Wert=0x03
; ITP3_CONST (C) BYTE Wert=0x04
; ITP3_CONIN (C) BYTE Wert=0x05
; ITP3_CLIENT_INIT (P) 
; ITP3_HALBBYTE_EINLESEN (F) 
; ITP3_BYTE_EINLESEN (F) 
; ITP3_HALBBYTE_AUSGEBEN (P) 
; ITP3_BYTE_AUSGEBEN (P) 
; ITP3_PRG_CONOUT (P) 
; ITP3_PRG_WHO_AM_I (P) 
; ITP3_PRG_CONST (P) 
; ITP3_PRG_CONIN (P) 
; ITP3_SERVER_ABFRAGE (P) 
; INITPORTS (P) 
; WAIT_MS2 (P) 
; TON (P) 
; TON2 (P) 
; TON3 (P) 
 
; *** Prozedur/Function-Liste ***
;
; FUNCTION BYTEPOSTOORMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION BYTEPOSTOANDMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION READ_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (VERGLEICH : BYTE) (MASKE : BYTE) : BOOLEAN;
; FUNCTION SET_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION CLEAR_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION NEGATION_BYTE (DAS_BYTE : BYTE) : BYTE;
; PROCEDURE WAIT_MS (ZEIT : WORD) (W1 : WORD) (W2 : WORD);
; PROCEDURE BYTETOSTRING (WERT_BYTE : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE) (C1 : CHAR);
; FUNCTION STRINGTOBYTE (HEXLOW : BYTE) (HEXHIGH : BYTE) (S2B : BYTE) (C1 : CHAR) : BYTE;
; PROCEDURE WORDTOSTRING (WERT_WORD : WORD) (BYTE_LOW : BYTE) (BYTE_HIGH : BYTE);
; FUNCTION STRINGTOWORD (C1 : CHAR) (S2W : WORD) (S2B : BYTE) (S2W2 : WORD) : WORD;
; PROCEDURE DWORDTOSTRING (WERT_DWORD : DWORD) (WORD_LOW : WORD) (WORD_HIGH : WORD);
; PROCEDURE TON_SIRENE (DAUER : WORD) (FREQUENZ : WORD);
; PROCEDURE CLICK;
; PROCEDURE KBD_INIT;
; FUNCTION READ_KEY (READ_KEY_VALUE : BYTE) (KEY_COUNTER : WORD) (B1 : BYTE) : BYTE;
; PROCEDURE WRITE_KEY (WRITE_KEY_VALUE : BYTE);
; PROCEDURE WRITE_C_KEY (CKEY : CHAR) (B1 : BYTE);
; PROCEDURE WRITE_TEXT (ZAEHLER : BYTE) (C1 : CHAR);
; PROCEDURE WRITE_DATA_WORD (R_WORD_LATCH : WORD) (R_COUNTER : BYTE);
; PROCEDURE TASTENNUMMER_ZU_TASTENZEICHEN (TASTEN_ZEICHEN : BYTE) (TN_WORD : WORD);
; PROCEDURE ANZEIGE_STATUS_LEDS;
; PROCEDURE TASTATUR_LESEN (W2 : BYTE);
; PROCEDURE ITP3_CLIENT_INIT;
; FUNCTION ITP3_HALBBYTE_EINLESEN (B1 : BYTE) : BYTE;
; FUNCTION ITP3_BYTE_EINLESEN (B1 : BYTE) (RESULT_BYTE : BYTE) : BYTE;
; PROCEDURE ITP3_HALBBYTE_AUSGEBEN (H_BYTE : BYTE) (B1 : BYTE);
; PROCEDURE ITP3_BYTE_AUSGEBEN (H_BYTE : BYTE) (B1 : BYTE);
; PROCEDURE ITP3_PRG_CONOUT (DATA_BYTE : BYTE);
; PROCEDURE ITP3_PRG_WHO_AM_I (DATA_BYTE : BYTE);
; PROCEDURE ITP3_PRG_CONST (DATA_BYTE : BYTE);
; PROCEDURE ITP3_PRG_CONIN (DATA_BYTE : BYTE);
; PROCEDURE ITP3_SERVER_ABFRAGE (CODE_BYTE : BYTE);
; PROCEDURE INITPORTS;
; PROCEDURE WAIT_MS2 (ZEIT : WORD) (W1 : WORD) (W2 : WORD);
; PROCEDURE TON (FRQ : WORD) (DAUER : WORD) (W0 : WORD);
; PROCEDURE TON2;
; PROCEDURE TON3;
 
; *** Konstanten-ARRAYs ***
;
 
TASTENTABELLE_NORMAL:
.db    0x31,0x32
.db    0x33,0x34
.db    0x35,0x36
.db    0x37,0x38
.db    0x39,0x30
.db    0x00,0x00
.db    0x71,0x77
.db    0x65,0x72
.db    0x74,0x7A
.db    0x75,0x69
.db    0x6F,0x70
.db    0x05,0x1B
.db    0x61,0x73
.db    0x64,0x66
.db    0x67,0x68
.db    0x6A,0x6B
.db    0x6C,0x19
.db    0x0D,0x06
.db    0x79,0x78
.db    0x63,0x76
.db    0x62,0x6E
.db    0x6D,0x7F
.db    0x16,0x09
.db    0x03,0x20
 
TASTENTABELLE_SHIFT:
.db    0x2B,0x2D
.db    0x2A,0x2F
.db    0x28,0x29
.db    0x2C,0x2E
.db    0x3D,0x3F
.db    0x00,0x00
.db    0x51,0x57
.db    0x45,0x52
.db    0x54,0x5A
.db    0x55,0x49
.db    0x4F,0x50
.db    0x05,0x40
.db    0x41,0x53
.db    0x44,0x46
.db    0x47,0x48
.db    0x4A,0x4B
.db    0x4C,0x19
.db    0x0D,0x06
.db    0x59,0x58
.db    0x43,0x56
.db    0x42,0x4E
.db    0x4D,0x25
.db    0x26,0x24
.db    0x03,0x20
 
TASTENTABELLE_CTRL:
.db    0x3E,0x3C
.db    0x3B,0x3A
.db    0x21,0x22
.db    0x7B,0x5B
.db    0x5D,0x7D
.db    0x00,0x00
.db    0x11,0x17
.db    0x05,0x12
.db    0x14,0x1A
.db    0x15,0x09
.db    0x0F,0x10
.db    0x27,0x7C
.db    0x01,0x13
.db    0x04,0x06
.db    0x07,0x08
.db    0x0A,0x0B
.db    0x0C,0x7E
.db    0x0D,0x5E
.db    0x19,0x18
.db    0x03,0x16
.db    0x02,0x0E
.db    0x0D,0x5F
.db    0x23,0x5C
.db    0x60,0x20
 
